local Entity = class:extend("Entitiy")
local RECORDS = RECORDS
local getUpdateCount = getUpdateCount
local Operators = OPERATORS
function bot()
    vv = self:spawnBot(nil,self.player.tile.x+1,self.player.tile.y)
end
function find()
    vv:findPathTo(self.player)
end

function Entity:__init__(kwargs)
    self.active = true
    
    kwargs = kwargs or {}
    self._kwargs = kwargs
    
    self.uuid = kwargs.uuid or lume.uuid()
    self.toSet = {"x","y","life","vx","vy","source","w","h","angle"}
    
    self.angle = kwargs.angle or 0
    self._w,self._h = 0,0
    self.x = kwargs.x or 0
    self.y = kwargs.y or 0
    self.h = kwargs.h or 16
    self.w = kwargs.w or 16
    self.ax = kwargs.ax or 0
    self.ay = kwargs.ay or 0
    self.passive = kwargs.passive
    self.elasticity = kwargs.elasticity or 0
    self.parent = kwargs.parent or {}
    self._inView = 0
    
    self.vx, self.vy = kwargs.vx or 0,kwargs.vy or 0
    
    self.sight = kwargs.sight or 10
    self.collisionType = kwargs.collisionType or kwargs.colType or "slide"
    
    self.source = kwargs.source or "none.png"
    self.name = kwargs.name or "Entity"
    
    self.map = kwargs.map or error("No map!")
    self.world = self.map.world
    
    self.passive = kwargs.passive
    
    if not self.passive then
        self.world:add(self,self.x,self.y,self.w,self.h)
        self.rect = true
        self:getTile(true)
        --storing self in local game
        self.map.entities[self.uuid] = self
    end

    self.speed = {x=0,y=0}
    self.weight = 400
    self.gravity = 0
    self.initGravity = 500/2

    self._speed = 100
    self.bounced = {x=false,y=false}
    self.tmpBurnt = false
    
    self.life = kwargs.life or 100
    self.totalLife = kwargs.totalLife or self.life
    self.lifeBar = LifeBar:new({parent=self,w=self.w+(self.w/2)})
    
    self.old = {x=self.x,y=self.y}
    self.updateCount = getUpdateCount()
    
    self.minis = {}
    self.totalMinis = 0
    
    local data = {
        self.uuid,
        self.__class,
        self.x,
        self.y,
        self.w,
        self.h,
        self.angle,
        self.source,
        self.life,
        self.parent and self.parent.uuid
    }
    
    --[[if self.map.isClient then
        self.map.client:send("newEntityCreated", data)
    elseif self.map.isHost then
        self.map.host:sendToAll("createNewEntity", data)
    end]]
end

function Entity:getData()
    local parent = self.parent and self.parent.uuid
    local r = {
        self.uuid,
        self.__class,
        self.x,
        self.y,
        self.w,
        self.h,
        self.angle,
        self.source,
        self.life,
        parent
    }
    return r
end

function Entity:getAttacked(attacker)
    self.life = self.life - attacker.attack
end

function Entity:set(var, op, val)
    self[var] = val or op if 1 then return end
    local value = self[var]
    if type(op) == "string" and Operators[op] then
        value = operate(value,op,val)
    else
        value = op
    end
    self[var] = value
    
    return value
end

function Entity:getDisplacement()
    return self.x-self.old.x, self.y-self.old.y
end

function Entity:ignore(item)
    return item.isMini--false
end

function Entity:setX(x)
    self.world:update(self,x,self.y)
    self:set("x",x)
end

function Entity:setY(y)
    self.world:update(self,self.x,y)
    self:set("y",y)
end

function Entity:setPos(x,y,fX)
    x = x or self.x
    y = y or self.y
    self.world:update(self,x,y)
    self.x = x
    self.y = y
    self.flipX = fX or self.flipX

    if self.isPlayer then--??
        self.lifeBar.x = self:getCenter()
        self.lifeBar.x = self.lifeBar.x-self.lifeBar.w/2--self.x-self.lifeBar.w/4
        self.lifeBar.y = self.y-self.lifeBar.h-self.h/5
        self.hat:update(dt)
        self.hat2:update(dt)
    end
end

function Entity:setLife(l)
    self.life = l or self.life
end

function Entity:moveTo(...)
    return self:setPos(...)
end

function Entity:applyImpulseY(imp)
    self.vy = self.vy + imp
    --self:set("vy","+",imp)
end

function Entity:applyImpulseX(imp)
    self.vx = self.vx + imp
    --self:set("vx","+",imp)
    
end

function Entity:applyImpulse(impX,impY)
    self:applyImpulseX(impX)
    self:applyImpulseY(impY)
end

function Entity.checkCollision(item, other)
    if not other.isBackground then
        return item.collisionType
    end
end

function Entity:resolveCollision(col, notDo)
    self:changeVelocityByCollisionNormal(col.normal.x, col.normal.y)
    if col.normal.y == -1 then
        if not self.isMini and not self.isPlayer and not self.isDebris then
                --causes puff on land
                if not self.onGround then--self.vy<-15 then
                    self:createPuff(3,5)
                    media.sfx.player_landed:play()
                end
                self.gravity = 0
                self.vy = 0
                self.onGround = true
            
        end
    else
        self.onGround = false
    end
    
    if notDo then self:changeVelocityByImpulse(col) end
end

function Entity:move(x,y)
    local actualX, actualY, collisions, len = self.world:move(self,x,y,
    self.checkCollision)
    local col
    for i = 1, len do
        col = collisions[i]
        self:resolveCollision(col)
    end
    
    return actualX, actualY
end

function Entity:checkIfOnGround(ny)
  if ny < 0 then self.onGround = true return true 
  else self.onGround = false return false end
end

function Entity:changeVelocityByImpulse(col)
    
        local other = col.other
        if not other.isTile and not other.isPlayer then
            --push
            local y,x = col.normal.y, col.normal.x
            if y<0 and self.vy>other.vy then
                other:applyImpulseY(self.vy)
            elseif y<0 and self.vy<other.vy then
                self:applyImpulseY(other.vy)
            end
            
            if y>0 and self.vy<other.vy then
                other:applyImpulseY(self.vy)
            elseif y>0 and self.vy>other.vy then
                self:applyImpulseY(other.vy)
            end
            
            if x<0 and self.vx>other.vx then
                other:applyImpulseX(self.vx)
            elseif x<0 and self.vx<other.vx then
                self:applyImpulseX(other.vx)
            end
            
            if x>0 and self.vx<other.vx then
                other:applyImpulseX(self.vx)
            elseif x>0 and self.vx>other.vx then
                self:applyImpulseX(other.vx)
            end
        end
end

function Entity:changeVelocityByCollisionNormal(nx, ny, bounciness)
  local bounciness = bounciness or self.elasticity
  if not bounciness or bounciness == 0 then
      return
  end
  local vx, vy = self.vx, self.vy

  if (nx < 0 and vx > 0) or (nx > 0 and vx < 0) then
    vx = -vx * bounciness
    self.bounced.x = true
  end
  
  if (ny < 0 and vy > 0) or (ny > 0 and vy < 0) then
    vy = -vy * bounciness
    self.bounced.y = true
  end

  self.vx, self.vy = vx, vy
end

function Entity:chageVelocityByCollision(...)
    return self:changeVelocityByCollisionNormal(...)
end

function Entity:getCenter()
    return self.x + self.w / 2,
         self.y + self.h / 2
end

function Entity:updateGravity(dt)
    if self.isTurret then log(self.initGravity..","..self.vy) end
    if not self.gravity or self.gravity==0 then
        self.gravity = self.initGravity
    end
    --self:set("gravity",self.gravity+self.weight*dt)
    self.gravity = self.gravity+self.weight*dt
    local gravity = self.gravity
    if self.isCrawling then gravity = 0 end
    self.vy = self.vy + gravity*dt
    if self.onGround and self.vy>0 then
    --    self.vy = 0--??
    end
    if self.onGround then
        self.gravity = self.initGravity
    end
    
end

function Entity:updateVelocity()
    local trash = self.updateGravity and self:updateGravity(dt)
    trash = self.changeVelocityByKeys and self:changeVelocityByKeys(dt)
end

function Entity:update(dt, c)
    c = c or getUpdateCount()
    self.updateCount = self.updateCount + 1
    
    self.tmpBurnt = false
    self.old.x, self.old.y = self.x, self.y
    self.speed = {x=0,y=0}
    self._w, self._h = resizeImage(game:getSource(self.source),self.w,self.h)
    
    self:updateGravity(dt)
    
    local vx, vy = self.x+self.vx*dt,self.y+self.vy*dt
    

    local mx, my = self:move(vx,vy,dt)
    self.x, self.y = mx,my
    
    self:getTile()
    
end

function Entity:setAll() error()--if m5 then return end
    local var, val
    for i = 1, #self.toSet do
        var = self.toSet[i]
        val = self[var]
        if self["_old"..var] ~= val then
            self["_old"..var] = val
            self:set(var,val)
        end
    end
end

function Entity:drawLife()
    return self.lifeBar:draw()
end

function Entity:draw()

    love.graphics.draw(game:getSource(self.source),self.x,self.y,self.angle,
    self._w,self._h,self.w/2, self.h/2)
    self:drawLife()

end

function Entity:dir(n)
    if n > 0 then return 1 elseif n < 0 then return -1
    else return 0 end
end

function Entity:getDir(...)
    return self:dir(...)
end

function Entity:destroy(color)

    if self.rect then
        self.world:remove(self)
        self.rect = nil
    end
    
    self.active = false
    local trash = self.tile and type(self.tile)~="number" and self.tile:unUnit(self)
    if self.map.kill then self.map:kill(self) end
    if not self.passive then
        if not self.isBullet and not self.isPuff and not self.isMini and not self.isDebris then
            if not self.map.isOld then
                if color ~= false then
                   self:spawnDebris(color)
                end
            end
        end
    end
    
    
end

function Entity:spawnDebris(color)
    if not self.map.active then
        return
    end
    
    media.sfx.debris:play()
    
    color = color or self.color or "brown"
    
    local area = self.w * self.h
    local debrisNumber = math.floor(math.max(15, area / 100))
    

    for i=1, debrisNumber do
        local color = color
        if type(color) == "table" and type(color[1])~=number then
            color = lume.randomchoice(color)
        end
        
        Debris:new({
            map = self.map,
            x = math.random(self.x, self.x + self.w),
            y = math.random(self.y, self.y + self.h),
            color = color
        }
      )
    end
end

function Entity:accelerate(x,y)
    self.vx = self.vx + x
    self.vy = self.vy + y
end

function Entity:des(tt,x,y)
    tt=self.map:getTile(x,y)
    if tt and not tt.isBackground then
        tt:destroy()
    end
end

local function filter(item)
    if item.isBackground or item.isBullet or item.isMini then
        return false
    end
    return true
end

function Entity:canSee(target, strict, pp)
    if lume.distance(self.x,self.y,target.x,target.y)>self.sight then
        return false
    end
    
    if not strict then--self.map.fogOfWar then
        --return true
    end
    
    local filter = filter
    if ddy then filter = nil end

    local itemInfo, len = self.world:querySegment(self.x,self.y,target.x+target.w/2,target.y,filter)
    
    local pat = (not pp and self.patience) or len
    local llen = len
    for x = 1, len do
        local item = itemInfo[x]
        if item==target then
            return true
        end
        
        if item==self then
            llen = llen-1
        end
        
        if pat == x and item~=self then
            return false
        end
        
        if strict and item~=self then
            return false
        end
    end
    if llen == 0 then
        --right next to target
        return true
    end
    
    log("No result!"..len)
end

function Entity:getTile(ignore)
    if self.map.isScene then--getTile then
        return
    end
    
    if self.tile then
        self.tile.color = nil
        self.tile.unit = nil
    end
    
    if not self.active then
        return
    end
    
    local x, y = self.map:convertPixelToTile(self.x,self.y)
    local t = self.map:getTile(x,y)
    local map,pr,t2,t3,t4,t5,tUp = self.map,{}
    t2 = map:getTile(x,y+1) or pr
    t3 = map:getTile(x,y-1)
    
    if t and t.invincible and self.isPlayer and t3 then
        self:moveTo(t3._x, t3._y)
        self.tile = t3
        return
    end
    
    if not t then
        if self.isPlayer and not t3 and not ignore and not self.passive then
            self:die()
            return
        end
        
        if self.isBullet then
            self:passiveDestroy()
        end
        return
    end

    if not self.isBullet then
    
    t4 = map:getTile(x-1,y) or pr
    t5 = map:getTile(x+1,y) or pr
    t3 = t3 or {}
    tUp = not (t2.isBackground or t3.isBackground or t4.isBackground or t5.isBackground)
    
    --sometimes when player jumps up to a tile, tiles underneath
    --get dug up
    
    if not self.isDebris and not t.isBackground and tUp and not self.isMini then --.map:getTile(x,y+1).isBackground and not self.isMini then
        local tt
        for xx = -1,1 do
            if xx == 0 then
                t:destroy()
            else
                self:des(tt,x+xx,y)
                self:des(tt,x,y+xx)
                self:des(tt,x+xx,y+xx)
            end
        end
    end
    
    end
    
    assert(t)
 
    if not self.firstTile then
        self.firstTile = t
    end
    self.tile = t
    self.tile.unit = self
    
    return self.tile
end

function Entity:createPuff(min, max)
    local min = min or math.random(1,3)
    if max then
        min = math.random(min, max)
    end
    for i = 1,min do
        Puff:new({map=self.map,
            x=self.x + self.w,
            y=self.y + self.h / 2,
            minSize=16 * (1 - math.random()),
            maxSize=39,
            vx=2, vy=3}
        )
        
    end
end

function Entity:inView()
    return self._inView >= getUpdateCount()
end

return Entity