local Config = class:extend("Config")

Config.data = {
    {"In this world you move! Very surreal! Tap any key!"},
    {"Jump","Jump"},
    {"Move Left", "Left"},
    {"Move Right", "Right"},
    {"To survive you shoot! Very real!"},
    {"Shoot up", "ShootUp"},
    {"Shoot down", "ShootDown"},
    {"Shoot to the top left", "ShootTopLeft"},
    {"Shoot to the top right", "ShootTopRight"},
    {"Shoot to the bottom left", "ShootBottomLeft"},
    {"Shoot to the bottom right", "ShootBottomRight"},
    {"Shoot to the right", "ShootRight"},
    {"Don't worry, almost done!"},
    {"Shoot to the left", "ShootLeft"},
    {"You can also shoot with your mouse.."},
    {"...but this can be disabled in settings"},
    {"Forgot to mention you can build too"},
    {"With the 'build' button you can hold it and press shoot at the same time..."},
    {"...to place a block in that direction!"},
    {"Tap this so-called 'build' key", "Build"},
    {"You can pick up bullets and blocks too!"},
    {"These are picked up automatically..."},
    {"You can have up to 3 of each! So you can switch between them!"},
    {"Switch to bullet slot 1","Slot1"},
    {"Switch to bullet slot 2","Slot2"},
    {"Switch to bullet slot 3","Slot3"},
    {"You can also switch blocks by holding the 'build' key and the slot you want to equip!"},
    {"But if you have too many you'll have to drop one"},
    {"Drop the item you want by switching to it, using slots, when a fourth slot has an item..."},
    {"It's that easy!"}
}

function Config:__init__(kwargs)
  --  Underground.__init__(self,kwargs)
    self.entities = {}
    self.bullets = {}
    self.turrets = {}
    self.mc = mainMenu.current
    self.gore = 1
    self.isScene = true
    
    local gs = function(s) return game:getSource(s) end
    self.tileSources = {
        ["iron.png"] = gs("iron.png"),
        ["background_dirt.png"] = gs("background_dirt.png"),
        ["dirt.png"] = gs("dirt.png"),
        ["stone.png"] = gs("stone.png")
    }
    
    self.font = love.graphics.getFont()
    self.message = ""
    
    self.tile = {w=1,h=1}
    game.map = self
    self.world = bump.newWorld()
    self.floor = Entity:new({map=self,w=W(), h=H()/6, x=-W()/2, y=H()-(H()/6),vy=0,vx=0})
    self.floor.isFloor = true
    
    self.player = Player:new({map=self,x=0,y=H()-(H()/6)-15})
    self.player.createPuff = function(self)
        local min = min or math.random(0,1)
        self.madePuff = 3
        if max then
            min = math.random(min, max)
        end
        for i = 1,min do
            Puff:new({map=self.map,
                x=self.x + self.w,
                y=self.y + self.h / 2,
                minSize=16 * (1 - math.random()),
                maxSize=39,
                vx=2, vy=3}
            )
            self.stats.dustProduced = self.stats.dustProduced+1
        end 
    end
    
    self.player.real= true
    self.hasPeer = null
    assert(self.player.world==self.world)
    
    self.player.getAttacked = function(self)
        if not self.dead then
            self:die()
            self.map.timer=1.5
            self.map.dead=1
        end
    end
    
    game.players = {self.player}
    
    self.camera = Camera()
    self.camera.scale = 3
    self.timer = 3
    self.active = 4
    
	self.canvas = love.graphics.newCanvas(love.graphics.getDimensions( ))
    love.graphics.setCanvas(self.canvas)
    local size = 50
    self.tiles = {}
    local s = game:getAsset("tiles/background_dirt.png")
    local tt = game:getAsset("tiles/dirt.png")--self.tileSources["dirt.png"]
    local tw,th = resizeImage(s,W()/size,W()/size)
    for x = 1,size*2 do
        for y = 1,size do
            t = {s,tt}
            t.w, t.h = W()/size,W()/size
            t.x = (x-1)*t.w
            t.y = (y-1)*t.h
            t._w, t._h = tw,th
            self.tiles[#self.tiles+1] = t
            love.graphics.draw(t[1],t.x,t.y,0,t._w,t._h)
            love.graphics.draw(t[2],t.x+self.floor.x, t.y+self.floor.y, 0, t._w,t._h)
        end
    end
    self.totalTiles = 0--#self.tiles
    log(inspect(self.player,1).."player")
    love.graphics.setCanvas()
    self.message="Jump Up"
    self.index = 0
    love.keyboard.setTextInput(true)
    self.messageLast = 2
    self.tmpMessageLast = self.messageLast
    
    local mw, mh = W()/4,((H()/10)+50+10)
    local font = love.graphics.getFont()
    fh = font:getHeight()
    self.messages = {}
    self.messageLen = {}
    for x = 1, math.floor((H()-mh)/(fh*2)) do
        table.insert(self.messages,{"",0,mh+(x*fh)})
    end
    self.messageLen.h = #self.messages
 --   self.messageLen.w = mw/font:getWidth()
    self._mh = mh
    self._mw = mw
    self.font = font
    self.messages = {}
    self:moveOn()
end

function Config:sendMessage(mes,color,isPrivate)
    local _color,_mes = color or game.settings.color,mes
    if type(_color) == "string" then
        color = getColor(_color)
    elseif _color then
        error("Color should be text")
    end
    
    mes = lume.wordcut(mes)--self._mw/(self.font:getWidth(mes)*2))
    local n,x, messes
    for x = 1,#mes do
        n = x+#self.messages
        if n>self.messageLen.h then
            messes = lume.copy(self.messages)
            for xx = 1,#messes do
                self.messages[xx] = messes[xx+1]
            end
            self.messages[-1] = nil
            n = self.messageLen.h
        end
        
        self.messages[n] = {mes[x],color}
    end
    
end

function Config:drawMessages()
    local mm = #self.messages
    if mm == 0 then
        return
    end
    local m,r,g,b,a-- = table.concat(self.messages)
    for x = 1,self.messageLen.h do
        m = self.messages[x]
        if m then
            if m[2] then
                r,g,b,a = love.graphics.getColor()
                love.graphics.setColor(m[2])
            end
            love.graphics.print(m[1],10,self._mh+(x-1)*self.font:getHeight()*2,0,2,2)
            if m[2] then
                love.graphics.setColor(r,g,b,a)
            end
        end
    end
end
        

function Config:getTile()
end

function Config:storeBullet(u)
    self.entities[u.uuid] = u
end

function Config:playerDied()
end

function Config:getTileP()
    return nil
end

function Config:kill(u)
    self.entities[u.uuid] = nil
end

function Config:moveOn(n)
    self.index = self.index+(n or 1)
    love.keyboard.setTextInput(true)
    if self.data[self.index] then
        self.currentData = self.data[self.index]
        self.message = self.currentData[1]
    else
        self:endConfig()
    end
end

local ddt = 0
function Config:activate(key)
    local d = self.currentData
    if not d[2] then
        return self:moveOn()
    end
    IM.KEYMAP[d[2]] = {key}
    self[d[2]](self, ddt)
    self:sendMessage("KEY "..key..": "..d[2])
    self:moveOn()
end

function Config:Jump()
    self.player:jump()
end

function Config:Left(dt)
    self.player:changeVelocityByKeys(dt,-1,0)
    self.player.flipX = -1
end

function Config:Right(dt)
    self.player.vx = 0
    self.player:changeVelocityByKeys(dt,1,0)
    self.player.flipX = 1
end

function Config:ShootUp(dt)
    self.player.vx = 0
    self.player:changeVelocityByKeys(dt,0,0)
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootUp"]),"Bullet")
end

function Config:ShootDown()
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootDown"]),"Bullet")
end

function Config:ShootTopRight()
    self.player.flipX = 1
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootTopRight"]),"Bullet")
end

function Config:ShootTopLeft()
    self.player.flipX = -1
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootTopLeft"]),"Bullet")
end

function Config:ShootBottomLeft()
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootBottomLeft"]),"Bullet")
end

function Config:ShootBottomRight()
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootBottomRight"]),"Bullet")
end

function Config:ShootRight()
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootRight"]),"Bullet")
end

function Config:ShootLeft()
    self.player.currentBullet = "Bullet"
    self.player:shoot(math.rad(self.player.paddy.shootAngles["ShootLeft"]),"Bullet")
end

function Config:Build()
end

function Config:Slot1()
end

function Config:Slot2()
end

function Config:Slot3()
end

function Config:update(dt)
    ddt = dt

    for x, i in pairs(self.entities) do
        if i~=self.floor then
           i:update(dt)
        end
    end
    
    ---self.player.vx = self.player.vx/2
    if self.player.vx<3 then
        --self.player.vx = 0
    end
    if self.player.y>self.floor.y+self.floor.h then
        self.player.y=H()-(H()/6)-15
        self.player.x=0
        self.player:setPos()
        self.index = self.index-1
        self.message = "Okay, you fell off the stage, let's try again!"
        self.player.vx = 0
        self.currentData = {}
    end
    self.camera:follow(self.player.x, self.player.y)
    self.camera:update(dt)
    self.timer = self.timer-dt
    

end

function Config:draw()
    self.camera:attach()
    self.player.real = false
    love.graphics.draw(self.canvas,-W()/2,0)
    
    local r,g,b,a = love.graphics.getColor()

    --love.graphics.setColor(getColor("woodbrown"))
    --love.graphics.rectangle("fill",self.floor.x, self.floor.y, self.floor.w, self.floor.h)
    --love.graphics.setColor(r,g,b,a)

    for x, i in pairs(self.entities) do
        if i~=self.floor then
            i:draw()
        end
    end
    self.camera:detach()
    local m = self.message
    love.graphics.print(
        m,
        W()/2-(self.font:getWidth(m)*2)/2,
        H()-(H()-self.font:getHeight()*2),
        0,2,2)
    self:drawMessages()
end

function Config:endConfig()
    game.map = nil
    game.settings.keys = KEYMAP
    game:saveSettings()
    game.players = {}
  --  mainMenu.create(mainMenu.menus.settings)
    mainMenu.current = self.mc
    mainMenu:create()
    GSS(mainMenu)
    log(IM.KEYMAP)

end

function Config:convertPixelToTile(x,y)
    local xx,yy = x/16,--self.parent.tileW,
    y/16--self.parent.tileH
    if xx<1 then xx = xx+1 end
    if yy<1 then yy = yy+1 end
    return xx,yy
end

function Config:mousereleased()
    gooi.released()
end

function Config:keyreleased(k)
    self:activate(k)
end

return Config