local tiles = {}
tiles.Tile = Tile:extend("Tile")
tiles.Tile.amount = {15,40}
function tiles.Tile:__init__(kwargs)
    Tile.__init__(self,kwargs)
    if self.parent==game.player then
        self.source = "dirt.png"
    end
    self.minis = {}
end


---Iron Tile---
tiles.Iron = Tile:extend("Iron")
tiles.Iron.amount = {6,15}

function tiles.Iron:__init__(kwargs)
    kwargs.passive = 1
    Tile.__init__(self,kwargs)
    self.source = "iron.png" log("!! iron spawn")
    self.life = 50
end

--turret--
tiles.Turret = Tile:extend("Turret")
tiles.Turret.amount = {2, 5}

function tiles.Turret:__init__(kwargs)
    --Tile.__init__(self,kwargs)
    --self.life = 50
    self.x = kwargs.x or 0
    self.y = kwargs.y or 0
    self.h = kwargs.h or 16
    self.w = kwargs.w or 16
    self._x = kwargs._x or self.x*self.w
    self._y = kwargs._y or self.y*self.h
    self.real = kwargs.real
    self.map = kwargs.map
    self.passive = kwargs.passive
    self.source = kwargs.source or "turret.png"
    self.ignoreSource = true
    self.life = 3
    self.isBackground = 1
    self.minis = {}
    self.totalMinis = 0
    if self.real and not self.map.isClient then
        self.turret = Turret:new({
            map=self.map,
            x=self._x,
            y=self._y,
            parent=kwargs.parent
        })
    elseif self.map.isClient and self.real and kwargs.parent 
    and kwargs.parent.team==self.map.player.team then
        self.map.client:send("requestTurretSpawn",{
            self._x,self._y,kwargs.bullet,self.map.player.team
        })
    end
end

--[[function tiles.Turret:update(dt)
    Tile.update(self,dt)
    self.turret:update(dt)
end

function tiles.Turret:draw()
    Tile.draw(self)
    self.turret:draw()
end]]

function tiles.Turret:destroy(...)
    Tile.destroy(self,...)
    if self.turret then self.turret:destroy() end
end

return tiles