local Bot = Player:extend("Bot")
local log = null

function Bot:__init__(kwargs)
    self.real = false
    Player.__init__(self,kwargs)
    
    self.map:storeBullet(self)
    
    self.rest = 0
    self.moveOn = 0
    
    self.aim = kwargs.aim or 1
    
    --self.currentBullet = "Bullet"
    self.range = 40 * self.map.tileW
    self.sight = self.range
    self.patience = kwargs.patience or 3
    
    self.backShooting = false
    self.canRebootPath = true
    self.isCalm = kwargs.isCalm
    
    self.team = kwargs.team or self.uuid
    self.notAggressive = kwargs.notAggressive
    self.working = true
    
    self.targetTimer = 0
    self.triesUntilMoveOn = 2
    
    self.timeToReloadTarget = 2
    self.reloadTargetTimer = 0
    
    self.lastBuildTime = 0

end

function Bot:work(calm)
    self.canRebootPath = true
    self.working = true
    self.isCalm = calm
end

function Bot:canShootBlocks()
    return true
end

function Bot:findPathTo(x,y,destroyBlocks)
    if self.dead then
        return
    end
    
    self.pathAttempt = (self.pathAttempt or 0)+1
    local ttt
    if self.pathAttempt > 3 then
        self.pathAttempt = self.pathAttempt-2
        log("path attempt fail!")
        if self.pathAttempt<3 then
            
        end
        return
    end
    
    if type(x)=="table" then
        destroyBlocks = y
        ttt=x
        if x.isMini then
            ANY_PATH = true
        end
        if x._x then
            y = x._y
            x = x._x
        else
            y = x.y
            x = x.x
        end
    end

    local t = self.map:getTileP(x,y)
    --if t then t.color = getColor("blue") else error(tostring(ttt.tile)..inspect(ttt,2)) end
    
    local goalInAir = self.map:getTile(t.x-1,t.y).isBackground and
    --local rightTile = 
    self.map:getTile(t.x+1,t.y).isBackground and
    --local upTils = 
    self.map:getTile(t.x,t.y-1).isBackground and
    --local downTile = 
    self.map:getTile(t.x,t.y+1).isBackground
    
    
    if not t then return end
    
    self.goal = {x=t._x,y=t._y}
    local tt = self.map:getTileP(self.x, self.y)
    
    if not tt then warn("cow") return end
    
    if t._y>tt._y then
        goalIsDown = true
    end
    
    if goalInAir and not goalIsDown and not self:hasLowBlocks() then
        --shoot if I can
        if ttt and not ttt.isMini and self:canSee(ttt) then
            self:shootAt(ttt)
        end
        
        return
    end
    
    canDestroyBlocks = destroyBlocks
    xDirToGoal = self:getDir(tt.x-t.x)
    
    path = self.map.pathfinder:getPath(tt.x,tt.y,t.x,t.y)
    self.currentPosInPath = 1
    
    local _path = {}
    if path then
        for x,c in path:nodes() do 
            x.x =x:getX()*self.map.tileW
            x.y=x:getY()*self.map.tileH
            x._x = x:getX()
            x._y = x:getY()
            table.insert(_path,x)
        end
    end

    if (not path or #_path==0) then
        log("Failed to find path from "..tt.uuid.." to "..t.uuid)
        local tunit = t.unit and t.unit.class or "None"
        local ttunit = tt.unit and tt.unit.class or "None"
        log("Units by "..ttunit.." and "..tunit)
        log("Backgrounds at "..tostring(tt.isBackground).." and "..tostring(t.isBackground))
        --t.color = getColor("blue")
    end
    
    if (not path or #_path==0) and not destroyBlocks then
        if self:canShootBlocks() then
            goalIsDown = nil
            xDirToGoal = nil
            canDestroyBlocks = nil
            return self:findPathTo(x,y,true)
        end
    elseif (not path or #_path==0) and destroyBlocks then
        if not self:hasLowBlocks() then
            log("any path now")
            goalIsDown = nil
            xDirToGoal = nil
            canDestroyBlocks = nil
            ANY_PATH = true
            local p = self:findPathTo(x,y,self:canShootBlocks())
            if not p then _warn("Still no path") end
            ANY_PATH = false
            return p
        end
    elseif #_path~=0 then
        self.pathAttempt = 0
        self.triesUntilMoveOn = #_path
        log("reload path attempt")
    end
    
    self.path= _path
    
    --debugging
    if not ppt and self.path then 
        for x,i in ipairs(self.path) do
            tt =self.map:getTile(i._x,i._y)
            --tt.color = getColor("white")
        end
    end
    
    self.rest = -1
    goalIsDown = nil
    xDirToGoal = nil
    canDestroyBlocks = nil
    ANY_PATH = false
    
    if self.path then log("goal?: "..inspect(self.goal,3)..", path!!!!"..#self.path.."\n"..inspect(self.path,2)) end
    return self.path
end

function Bot:isFreeFalling()
    local tile = self.tile
    if not tile then
        return
    end
    
    local target = self._target
    if self.waitngForGoal and target and target.isMini then
        return
    end
    
    local downTile = self.map:getTile(tile.x,tile.y+1)
    
    if not downTile.isBackground then
        return
    end
    
    local leftTile = self.map:getTile(tile.x-1,tile.y)
    local rightTile = self.map:getTile(tile.x+1,tile.y)
    if  downTile.isBackground and
        --leftTile.isBackground and
        --rightTile.isBackground and
        self.vy>0
    then
        if self.path then
            local p = self.path[self.currentPosInPath]
            if p and p._y>tile.y then
                --all according to plan, so no worries
                return false
            elseif p and p._y<=tile.y then
                return true
            end
        end
        if self._targetToShoot or self.shootingTarget then
            return true
        end
    end
    
    return false
end
      

function Bot:moveUp(d)
    self.Ljoystick.dy= -1*(d or 1)
    log("up")
end

function Bot:moveDown(d)
    self.Ljoystick.dy = 1*(d or 1)
end

function Bot:moveRight(d)
    self.Ljoystick.dx = 1*(d or 1)
end

function Bot:moveLeft(d)
    self.Ljoystick.dx = -1*(d or 1)
end

function Bot:moveDir(dx,dy)
    self.Ljoystick.dx = (dx or self.Ljoystick.dx)
    self.Ljoystick.dy = (dy or self.Ljoystick.dy)
    log("moving "..dx..","..dy)
end

function Bot:restBuildTime(n)
    self.lastBuildTime = n or 1
end

function Bot:refreshTimers(dt)
    self.targetTimer = self.targetTimer-dt
    if self.targetTimer <=0 then
        --self._target = nil
        --self.path = nil
        --self.rest = 4
        self.targetTimer = 5
        self.path = nil
    end
    
    local dx,dy = self:getDisplacement()
    if dx==0 and dy == 0 then
        self.reloadTargetTimer = self.reloadTargetTimer+dt
    else
        self.reloadTargetTimer = 0
    end
    
    if self.reloadTargetTimer > self.timeToReloadTarget then
        log("resette")
        self:resetTarget()
        self.reloadTargetTimer = 0
    end
    
    self.lastBuildTime = self.lastBuildTime-dt
end

function Bot:log(text)
    log(string.format("====%s is %s====",tostring(self),text))
end

function Bot:updateLogic(dt)
    self._targetToShoot = nil
    
    local noMove
    local attacker = self:getEnemyShootingMe()
    local target = self:getTargetToShoot()
    local targetToChase = (self._target and self._target.isMini and self._target) or self:getTargetToChase()
    if targetToChase and targetToChase.isMini then 
        log("Targ mini!")
    end
    
    --self.map.player.name = self:countAllBlocks()--self.blockStorage[1][2]--tostring(self:hasLowBlocks())
    
    local healthCrate = self.map:getCrate("health")
    local bulletCrate = self.map:getCrate("bullet")
    
    local lowLife = math.random(25,30)
    
    if (self:isBeingShotAt() and self:lifeIsBelow(50)) and self:canBuild() then
        self:log("defending")
        self:defendAgainst(attacker)
        
    elseif self:lifeIsBelow(50) and healthCrate then
        self:log("health crate")
        self:chaseCrate(healthCrate)
    
    elseif self:lifeIsBelow(lowLife) and attacker then
        self:log("running away")
        self:runAwayFrom(attacker)
    
    elseif self:hasLowBlocks(10) and self.tunnelDir then
        self:log("digging")
        self:digTunnel()
        return
    
    elseif self:hasLowBlocks() and self._target and self._target.isCrate then
        self:log("shooting crate")
        self:chaseCrate(self._target)
        if targetToChase and self:canSee(targetToChase) and not targetToChase.isMini then
        self:shootAt(targetToChase)
        log("shooting block")
        end
        return
    
    elseif self:hasLowBlocks() 
    and not (targetToChase and targetToChase.isMini) then
        if not self.shootingTarget and not self.ggtt then
            self:refillBlocks()
            log("low blocks")
        else
            self:refreshGettingBlocks()
        end
        return
    end
     
    self.tunnelDir = nil
     
    if target then
        --self:shootAt(target)
        if self.isCalm then
            --return
        end
    end
    
    if targetToChase and self:canSee(targetToChase) and not targetToChase.isMini then
        self:shootAt(targetToChase)
        self._targetToShoot = targetToChass
        if self.isCalm then
            noMove = true
        end
    elseif targetToChase and targetToChase.isCrate then
        self:shootAt(targetToChase)
    end

    
    if bulletCrate and self:hasOtherLowBullets() then
        self:chaseCrate(bulletCrate)
    
    elseif targetToChase and not noMove then
        if self.path then
            log("path , just flow")
            --if targetToChase.isMini then game.map.player.name = "Heyo" end
            self:refreshPathObjectives()
            self:chaseTarget()
        else
            log("get p first")
            self._target = nil
            --if targetToChase.isMini then game.map.player.name = "find" end
            self:chaseTarget(targetToChase)
        end
    
    end
end

    

function Bot:update(dt)
    if self.map.updated[self] then
        return
    end
    
    self.map.updated[self] = true
    
    local p = RECORDS.updateCount
    
    oldu = p
    
    if vv==self then
        log("vvv")
    else 
        ww = self log("www")
    end
    --_logg =_logg or log log=null end
    
    self._canShoot = true
    
    self:refreshTimers(dt)

    self.real = true
    Player.update(self,dt)
    
    if not self.path then
  --      self.Ljoystick:releaseStick()
    end
    
    self.real = false
    
    if self.dead then
        return
    end

    self:updateLogic(dt)
    self:saveSelfFromFalling()
    self:resetTargetIfDead()
    

    --if vv==self then log=_logg end
end

function Bot:chaseTarget(target)
    log("chasing "..tostring(target))
    if target and target~=self._target then
        self._target = target
        self:cancelRest()
        self:refreshPathObjectives() log("44- loaded target again")
        return
    end
    
    if (target==nil and self._target==target) then
        return
    end
    
    
    local x,y = self.tile.x,self.tile.y
    local leftTile = self.map:getTile(x-1,y)
    local rightTile = self.map:getTile(x+1,y)
    
    log("path is "..tostring(self.path))
    
    if self.waitingForGoal and self._target and self._target.isMini and self._target.life>0 then
        log("waitingfg") return
    else
        self.waitingForGoal = nil
    end

    if self.path and (
        not self.isCialm or (
            self.isCalm and 
            (not self:targetIsClose() or
            (self._target and self._target.isMini))
        )
    )
    then
    
        local minDistance = 1--self.map.tileW
        --do check for self.isCalm here
        local p = self.path[self.currentPosInPath]
        local pn = self.path[self.currentPosInPath]
        local pp = pn or self.tile
        local t = self.map:getTile(pp._x,pp._y)
        
        if t and not t.isBackground then
            self:shootAt(t)
            log("shooting")
        end
        
        if not p then
            local pp = self.path
            self.path = nil
            self.rest = 5
            log("Not p at "..self.currentPosInPath..","..#pp)
        else
            local tw, th = self.map.tileW, self.map.tileH
            local tx, ty =self.x, self.y--
            local ttx, tty = self.tile.x, self.tile.y
            
            local dx, dy = p._x-ttx, p._y-tty
            local dis = lume.distance(p._x,p._y,ttx,tty)
            
            log("from "..p._x..", "..p._y.." to "..self.tile.uuid)
            if self.precise then--.target then--and self.target.isMini then
                if self._target and self._target.isMini then
                    dis = lume.distance(p.x, p.y, tx, ty)
                end
                
                --local dyy = dy
                dx = p.x-tx--, p.y-ty
                log("changed to "..dx..","..dy.."dis:"..dis)
            end
                
            if dis<minDistance then
                self.currentPosInPath = self.currentPosInPath+1
                --self.rest = self.rest+1
                self.Ljoystick:releaseStick()
                self.precise = false
                log("Next Path pos")
            else
                if dx==0 and dy~=0 then
                    if not rightTile.isBackground then
                        dx = 1
                    elseif not leftTile.isBackground then
                        dx = -1
                    end
                end
                if p == self.oldp then
                    self.moveOn = (self.moveOn or 0)+1
                end
                self.oldp = p
                local dirx, diry = self:getDir(dx), self:getDir(dy)
                
                log("moved "..dx..","..dy)
                for x, i in ipairs({{dx,dy},{-1,-1},{1,-1},{0,-1},{-1,0},{-1,1},{1,1}}) do
                    local dx, dy = i[1],i[2]
                    local dirx, diry = self:getDir(dx), self:getDir(dy)
                    local t = self.map:getTile(self.tile.x+dirx, self.tile.y+diry)
                    if not t.isBackground then
                        self:shootAt(t)
                        log("shooting tile")
                        break
                    elseif t.invincible then
                        log("GOT INVINCIBLE TILE IN PATH!")
                    end
                end
                
                self:moveDir(dirx, diry)
            end
        end
        --self.rest = self.rest+dt
        if self._target and not self._target.isMini then
            if self:canSee(self._target) then
                self:shootAt(self._target)
            end
        end
        
        return true
    elseif (
            self.isCalm and 
            (not self:targetIsClose() or
            (self._target and self._target.isMini))
        ) then assert(not self.path)
        self.rest = (self.rest or 0)+1
        log("tried")
        
    elseif self.isCalm and not (
  
            (not self:targetIsClose() or
            (self._target and self._target.isMini))
        ) then
            log("No way, duty calls")
            if self._target and not self._target.isMini and self:targetIsClose(self._target) then
                self:shootAt(self._target)
            end
    else
        self._target = nil
        self:chaseTarget(target)
        log("????? Nonpath")
        
    end
end

function Bot:cancelRest()
    log("cancelling rest")
    self.rest = 5
end

function Bot:saveSelfFromFalling()
    if self:isFreeFalling() then
        self:placeBlock(0,1)
    end
end
    
function Bot:refreshPathObjectives()
    if self._target and self._target.life<=0 then
        log("reset, dead target")
        self:resetTarget()
    end
    
    if self.working then
        if self.rest>4 and self._target and self.working then
            log("rest over, path again")
            self:findPathTo(self._target)
            if not self.path then
                log("no path gotten from working")
                if self._target.isCrate and
                self._target.tile.x==self.tile.x and self._target.y<self.y then
                    self:shootAt(self._target)
                    log("shooting at crate")
                end
            end
            
            self.rest = 0
        elseif not self._target then
            --self.rest = 0
        end
    end
    
    if self.moveOn>self.triesUntilMoveOn and self.canRebootPath then
        self.currentPosInPath = self.currentPosInPath+1
        self.precise = true
        log("moving on")
        self.moveOn = 0
    end
end
    
function Bot:refreshGettingBlocks()

    if not self.shootingTarget then
        --self.ggtt = nil
    end
    
    if self.shootingTarget then
    
        self.working = nil
        self.path = nil
        self.target = nil
        self._target = nil
        
        local sh = self.shootingTarget

        self.oldb = self.oldb or self.breakBlocks
        if sh.parent and sh.parent.team==self.team then
            self.breakBlocks = true
        end
    
        self:shootAt(self.shootingTarget)
       -- self.breakBlocks = oldb
        
        if (self.shootingTarget.life<=0 and self.shootingTarget.totalMinis>0)
        or (self.shootingTarget.life<=0 and self.shootingTarget[self.uuid] and self.shootingTarget[self.uuid]>3)
        or (self.shootingTarget[self.uuid] and self.shootingTarget[self.uuid]>14)
        then
            local t = self.shootingTarget
            
            if (self.shootingTarget[self.uuid] and self.shootingTarget[self.uuid]>14) then
                log("Taking TOO long")
            end
            
            if t.isTile then
                local mini = lume.randomchoice(t.minis)
                if mini then
                    self.target = mini
                    self._target = mini
                    self:cancelRest()
                    self.working = true
                    --ANY_PATH = true
                    --self:findPathTo(self.target)
                    --ANY_PATH = false
                    log("chase"..tostring(self))
                    log(self.waitingForGoal)
                    
                end
            end
        
            self.shootingTarget[self.uuid] = nil
            self.shootingTarget = nil
            self.breakBlocks = self.oldb
            self.oldb = nil
        else
            self.shootingTarget[self.uuid] = (self.shootingTarget[self.uuid] or 0)+1
        end
        
    elseif self.target then
        if self.path then
            self:refreshPathObjectives()
            self:chaseTarget()
            log("chasing mini")
        else
            ANY_PATH = true
            self:chaseTarget(self.target)
            ANY_PATH = false
        end
    end
end

function Bot:defendAgainst(attacker)
end

function Bot:hasOtherLowBullets()
end

function Bot:resetTargetIfDead()
    local target = self._target or self.target
    if target then
        if not target.active then
            
            if target.isMini then
                log("caught "..tostring(self).."?")
                --game.map.player.name = self.blockStorage[1][2]
                self.waitingForGoal = nil
            end
            log("Targ is dead")
            self:resetTarget()
        end
    end
end

function Bot:getTargetToChase()
    if self._target then
        return self._target
    end
    return self:getAnyTarget()
end

function Bot:isBeingShotAt()
end

function Bot:getEnemyShootingMe()
end

function Bot:lifeIsBelow(value)
    return self.life<value
end

function Bot:hasLowBlocks(n)
    return --hb or false--
    self:countAllBlocks()<(n or 3)
end

function Bot:canBuild()
    return self.lastBuildTime<=0
end

function Bot:countAllBlocks()
    local count = 0
    local block
    for i = 1,#self.blockStorage do
        block = self.blockStorage[i]
        count = count + block[2]
    end
    return count
end

function Bot:countBlocks(type)
    if not type then
        return self:countAllBlocks()
    end
    
    local block

    for i = 1,#self.blockStorage do
        block = self.blockStorage[i]
        if block[1]==type then
            return block[2]
        end
    end
    
    return 0
end

function Bot:getAvailableBlock()
    local blocks = {}
    local blockLen = 0
    
    for i = 1,#self.blockStorage do
        block = self.blockStorage[i]
        if blocks[2]>0 then
            blocks[blockLen] = i
            blockLen = blockLen+1
        end
    end
    
    return lume.randomchoice(blocks)
end

function Bot:useAvailableBlock()
    local block = self:getAvailableBlock()
    if not block then
        return
    end
    self.blo({data=block})
end

function Bot:lifeIsLow(target)
    if target then
        if self.life>target.life+10 then
            return false
        end
    else
        return self.life<self.totalLife/5
    end
end

function Bot:getTargetToShoot()
    local target = self._target or self.target
    target = target and not target.isMini and target
    if not target then
        target = self:getTarget()
    end
    
    if target then
        if self:canSee(target) then
            return target
        end
    end
end

function Bot:targetIsClose(target)
    local target = target or self._target
    if not target then
        return false
    end
    return self:canSee(target,self.map.fogOfWar)
end

function Bot:chaseCrate(crate)
    if not self.moveToTile or self.moveToTile[2]~=crate then
        log("re: chase")
        self:chaseTarget(crate)
        return
    end
    self.target = crate
    log("chasing crate")
    
    if 1 then
            if not self.path then
                log("no path gotten from working2")
                if crate.isCrate and crate.tile and
                crate.tile.x==self.tile.x and crate.y<self.y then
                    self:shootAt(crate)
                    log("shooting at crate")
                elseif crate.isCrate and crate.y<self.y then
                    self.moveToTile = self.moveToTile or { self.map:getTile(crate.tile.x,self.tile.y), crate }
                    self:chaseTarget(self.moveToTile[1])
                    log("to tile "..tostring(self.path))
                end
            end
    end
    
    if crate.life<=0 then
        
        self.target = nil
        
        local m = crate.minis[1]
        log("trying crate mini")
        if m then
            log("getting crate mini ")
            self:chaseTarget(m)
        end
        
    end
end

function Bot:resetTarget()
    log("reseting target")
    self.target = nil
    self._target = nil
    self.path = nil
    self.rest = 10
    self.working = true
    self.ggtt = nil
end

function Bot:getTarget(any)
    return self:getNearest(game.players,self.map.turrets,any)
end

function Bot:getAnyTarget()
    return self:getTarget(true)
end

function Bot:checkForUpTileToShoot()
    local x, y = self.tile.x, self.tile.y
    
    local tries = 1
    local maxTries = 30
    local tile
    while (not tile or tile.isBackground) and tries<maxTries do
        tile = self.map:getTile(x,y-tries)
        tries = tries+1
        if tile and (tile.invincible or tile.isBackground) then
            tile = nil
            break
        end
    end
    if tile then
        self.shootingTarget = tile
        self.waitingForGoal = true log("wait")
        if doDebug then
            self.tile.color = getColor("orange")
            tile.color = getColor("cyan")
            if tile.isBackground then tile.color=getColor("yellow") end
        end
        return true
    end
end

local dirs = {1,-1}
local ydirs = {1,1,-1,-1,-1}
function Bot:shootAtRandomTile()
    local tile
    local maxTries = 0
    while maxTries<15 and
    (not tile or
    tile.invincible or
    (tile.parent and tile.parent.team==self.team) or
    tile.isBackground
    ) do
        tile = self:getRandomThingAtSight("isTile")
        maxTries = maxTries+1
    end
    
    

    if tile and doDebug then tile.color = getColor("green") end
    self.shootingTarget = tile
end

local function filter(item)
    if item.isBackground or item.isBullet or item.isMini then
        return false
    end
    return true
end

function Bot:getRandomThingAtSight(requirement,notHave)
    local notHave = notHave or "invincible"
    local cx, cy = self.x, self.y--self:getCenter()
    local tx = cx+self.sight*self.w*randomchoice(dirs)
    local ty = cy+self.sight*self.h*randomchoice(ydirs)
    local w = self.sight*2*self.w
    local itemInfo, len = self.world:querySegment(cx,cy,tx,ty,filter)
    --local itemInfo, len = self.world:queryRect(cx-w/2,cy-w/2,w,w,filter)
    for x = 1, len do
        local item = itemInfo[x]
        if item[requirement] and not item[notHave] then
            return item
        end
    end
end

local digDirs = {{1,0},{-1,0},{0,1},{0,-1}}

function Bot:getTunnel()
    local tx, ty = self.tile.x, self.tile.y log("tt")
    for x = 1,4 do
        local dir = digDirs[x]
        local count = 0
        local start
        local tt
        for i = 1,5 do
            local xx,yy = (dir[1]*x)+dir[1], (dir[2]*i)+dir[2]
            local tile = self.map:getTile(xx+tx, yy+ty)
            if not tile or tile.invincible or (tile.isBackground and start) then
                start = false
                break
            end
            start = true
            tt = tile
        end
        if start then
           --log(tt)
           log("tunne"..tostring(tt or 0))
            return tt,dir
        end
    end
end

function Bot:digTunnel()
    if self.tunnelDir then
        local t = self.tunnelDir
        --[[self.map:getTile(
            self.tile.x+self.tunnelDir[1],
            self.tile.y+self.tunnelDir[2]
        )]]
        if not t or t.isBackground then
            self.tunnelDir = nil
            log("over")
        else
        log("chase t")
            self:chaseTarget(t)
            --t.color = getColor("blue")
        end
    end
end

function Bot:refillBlocks()
    --local quick = self._target and self._target:isClose() and not self:lifeIsLow() 
    
    self.tunnelDir = nil--self:getTunnel()
    if self.tunnelDir then
        return
    end
    local block = self.map:getCrate("block")
    
    if block then
        self:log("chasing block crate")
        block.what = true
        self:chaseCrate(block)
    
    elseif self:checkForUpTileToShoot() then
        self.waitingForGoal = true
        self:log("shooting up...?")
    elseif 1 then
        --no time to run away, we're not cowards!
        self.waitingForGoal = nil
        self:log("shooting at a random tile")
        self:shootAtRandomTile()
    else
        --go collect some proper tiles
        self:log("targeting crate")
        self:targetBlockCrate()
    end
end

function Bot:getNearest(objects,obj2,any)
    local distance, nearest, object, tx, ty
    local cx, cy = self.x, self.y--self:getCenter()
    local shortestDistance = (any and math.huge) or self.range---huge
    for i = 1, #objects do
        object = objects[i]
        if object.team~=self.team and object.life>0 and not object.dead then
            if self.map.player==object then
                --log("firing player at team "..object.team.."\n    My team is "..tostring(self.parent.team))
            end
            
            distance = self:getSquaredDistance(object)
        
            if distance < shortestDistance then
                tx, ty = object:getCenter()
                local itemInfo, len = self.world:querySegment(cx,cy,tx,ty,filter)
                
                local info
                
                for count = 1,3 do
                    if itemInfo[count]==object then
                        info = object
                        break
                    end
                end
                
                if (info and info==object) or any then
                    nearest = object
                    shortestDistance = distance
                    --warn("Target")
                end
            end
        end
    end
    if obj2 and #obj2>1 then
        for i = 1,#obj2 do
            object = obj2[i]
            if object.life>0 and object~=self and object.parent.team~=self.team then
                distance = self:getSquaredDistance(object)
        
                if distance < shortestDistance then
                    tx, ty = object:getCenter()
                    local itemInfo, len = self.world:querySegment(cx,cy,tx,ty,filter)
                    -- ignore itemsInfo[1] because that's always self?
                    local info
                    
                    for count = 1,3 do
                        if itemInfo[count]==object then
                            info = object
                            break
                        end
                    end
                    
                    if (info and info==object) or any then
                        nearest = object
                        shortestDistance = distance
                        --warn("Target")
                    end
                end
            end
        end
    end
                
    return nearest
end

function Bot:getSquaredDistance(object)
    return lume.distance(object.x,object.y,self.x,self.y)
    --local dx, dy = self.x - object.x, self.y - object.y
    --return dx*dx + dy*dy
end

ll=180
function Bot:getAngle(object)
    local aim = 1-self.aim
    local aimx, aimy = 1,1--(math.random(self.aim*10,10)/10)*lume.randomchoice(dirs),
    --(math.random(self.aim*10,10)/10)*lume.randomchoice(dirs)
    --log(aimx..","..aimy)
    
    local ang = -math.atan2(
        ((object._y or object.y)+object.h/2)-self.y+self.h*(1-aimy),
        ((object._x or object.x)+object.w/2)-self.x+self.h*(1-aimx))

    return ang
    
end

function Bot:shootAt(target) --if 2 then return end

    if not self._canShoot then
        log("tried to shoot twice!")
        return
    end
    
    
    local rr = self.real
    self.real = true
    local angle = self:getAngle(target)
    
    local nangle = -math.deg(angle)
    if angle~=0 then
        if nangle>90 and nangle<270 and not self.backShooting then
            self.flipX = -1
        elseif not self.backShooting then--if math.deg(angle)<180 and math.deg(angle)>0 then
            self.flipX = 1
        end
    end
    
    self.Rjoystick.angle = angle
    
    local b = self:shoot(angle)
    if b then
        if target.parent and target.parent.team==self.team or target.team==self.team then
            b.attackAll = true
        end
        --b.delay = 0.2
        --b.attack = 40
    end
    self.real = rr
    self._canShoot = false
    return b
end

function Bot:placeBlock(x, y, block,_tile)
    local rr = self.real
    self.real = true
    local tile = tile or self.tile

    local block = self.currentBlock

    local gb = self:getStorageIndex(self.blockStorage,self.currentBlock)
    local blo = self.blockStorage[gb]
    
    local xx,yy = tile.x, tile.y
    local t = _tile or self.map:getTile(xx+x,yy+y)
    
    if blo[2]<1 or not t.isBackground then
        return
    end
    
    --pushes player to it's tile position to avoid glitchy placement.
    --resets when block not placed for 2 seconds
    if self.real then--and not self.adjusted then
        self.x = tile._x
        self.y = tile._y
        self.map.world:update(self,self.x,self.y)
    end
    self.adjusted = 1
    
    if t and t.isBackground and not t.unit then--and #t.units<1 then
        t:changeTo(tiles[self.currentBlock]:new({
            x=t.x,
            y=t.y,
            map=self.map,
            tmp=true,
            parent=self,
            passive=1,
            real=1,
        }))
        blo[2] = blo[2]-1
    
        self.getChild(self.displayBlocks,gb):setText(blo[2])
    
    --doT, allow player to attack without gun--????
    elseif t and doT then
        t:getAttacked(.5)
        self.paddy.ignoreButton = .1
        return
    end
    
    self.stats.blocksPlaced = self.stats.blocksPlaced+1
    
    if self.real then
        self:send("do",{"placeBlock",t.x,t.y,block,true})
    end
    
    self.real = rr
    
end

function Bot:jump()
    if self.real then
        if not self.canJump then
            return
        end
        self:send("do",{"jump"})
    end
    
    if 1 then
        self.stats.jumpsPeformed = self.stats.jumpsPeformed+1
        self.sprite:switch("jumping")
        media.sfx.player_jumped:play()
        self.jumping = true
        self.vy = self.vy-self.jumpAcceleration--+jumpDec
        
        --create Puff when jumping off wall
        if self.wallOnSide then
            self:createPuff(5,7)
        end
        
        --stops player from flying prematurely
        if not self.canFly then
            self.canJump =  false
        end
    end
end



function Bot:_draw()

    local v = game:getSource(self.source)
    local xx,yy = v:getWidth()/2, v:getHeight()/2
    
    love.graphics.draw(game:getSource(self.source),self.x+xx,self.y+yy,self.angle,
    self._w,self._h,xx,yy)

    --self.paddy:draw()
end

function Bot:released(...)
    --self.paddy:touchreleased(...)
end

function Bot:pressed(...)
    --self.paddy:touchpressed(...)
end

function Bot:touchmoved(...)
    --self.paddy:touchmoved(...)
end

return Bot