--Bullet class

local Bullet = Entity:extend("Bullet",1000)
local LAST_SHOT = nil

local getUpdateCount = getUpdateCount

function Bullet:__init__(kwargs)
    self.isBullet = true
    self.name = kwargs.name
    self.map = kwargs.map or {world={add=null}}
    self.world = kwargs.world or self.map.world or {}
    kwargs.map = self.map
    kwargs.world = self.world
    kwargs.w = wb or kwargs.w or 5 --or 10 wb or kwargs.w or wb or 2--5
    kwargs.h= hb or kwargs.h or 3 --or 5 hb or kwargs.h or hb or .5--3
    
    Entity.__init__(self,kwargs)
    
    self.parent = kwargs.parent
    if not self.passive then
        self.map:storeBullet(self)
        self.map.entities[self.uuid] = self
    
        self.delay = self.delay or kwargs.delay or 0.25--(not De or 0.5)--????

        if not self.parent.LAST_SHOT then
            self.parent.LAST_SHOT = self.delay--love.timer.getTime()
        else
           local diff = --love.timer.getTime()-
           self.parent.LAST_SHOT
            if diff >= 0 then--self.delay then
                self:passiveDestroy()
                return self
            end
        end
        
        self.parent.LAST_SHOT = self.delay-- love.timer.getTime()
        self.parent = kwargs.parent or error("no parent")
        media.sfx.bullet_shot:play()
        
        self.world:remove(self)
        self.world:add(self, self.x-(bbx or 0),self.y-(bby or 5),self.w,self.h)
    end
    
    self.sfx = kwargs.sfx or "bullet_shot"
    self.source = kwargs.source or "bullets/bullet.png"
    self.firstSource = self.source
    
    if type(self.parent) == "string" then
        self.parent = self.map:getItem(self.parent) or {}
    end
    
    --assert(self.angle>0)
    self.angleY = math.sin(self.angle)
    self.angleX = math.cos(self.angle)
    
    if kwargs.passive then
        self:passiveDestroy()
        return self
    end
    
    
    self.ac = kwargs.speed or kwargs.ac or 500
    self.initGravity = kwargs.gravity or self.initGravity
    
    self.hits = kwargs.hits or 1
    
    --how many seconds bullet lasts
    self.life = kwargs.life or 60
    self.attack = kwargs.attack or 1.5
    
    self.vx = self.ac*self.angleX
    self.vy = self.ac*-1*self.angleY
    
    self.angleY, self.angleX=1,1
    self.ignoresParent = true
    self.collisionType = kwargs.collisionType or "cross"
    
    self._oldx = self.x
    self._oldy = self.y
    
    self.attackAll = kwargs.attackAll
    
end

function Bullet:detectExitedParent()
  if self.ignoresParent then
    local parent = self.parent
    if not self.parent.x then warn("parent is "..inspect(self.parent,1)) return end
    local x1,y1,w1,h1 = self.x, self.y, self.w, self.h
    local x2,y2,w2,h2 = parent.x, parent.y, parent.w-2, parent.h-2
    self.ignoresParent = x1 < x2+w2 and x2 < x1+w1 and y1 < y2+h2 and y2 < y1+h1
    if not self.ignoresParent then
        
    end
  end
end

function Bullet:update(dt, c) 

    if not self.active then
        return
    end
    
    self._w, self._h = resizeImage(game:getSource(self.source),self.w,self.h)


    self.bounced.x = false
    self.bounced.y = false
    
    local vx, vy = self.x+self.vx*dt*self.angleX,self.y+self.vy*dt*self.angleY

    
    local mx, my = self:move(vx,vy,dt)
    self.x, self.y = mx,my
    

    self:detectExitedParent()
    self:checkNearPlayer(dt)

    self:getTile()
  
end
bbx,bby=0,-10
minv = 15
function Bullet:checkNearPlayer(dt)
    local near = false
    if (not self.active) then
        return
    end
    for x = 1,#game.players do
        local player = game.players[x]
        if (player~=self.parent and player.life-(self.attack*self.hits)<=0 and lume.distance(self.x-bbx, self.y-bby, player.x+player.w/2, player.y+player.h/2)<(self.map.slowRange or -1000000) and
        math.random()<self.map.slowChance) then
            local sx, sy = self.x, self.y
            for xx = 1,(ct or 2) do
                local kv = 10
                sx, sy = sx+self.vx*dt*kv*self.angleX,sy+self.vy*kv*dt*self.angleY
                local gx, gy, cols, len = self.world:check(self,sx,sy,self.checkCollision)
                sx, sy = gx, gy log("Cols at "..len)
                for c = 1,len do
                    if cols[c].other == player then
                        self:slow(player)
                        self.map:tag(self)
                        return
                    end
                end
                self.world:update(self, sx,sy)
            end
        end
    end
end

function Bullet:slow(player)
        self.map.slowTarget = player
        self.map:slowDown()
        --self.map.player.line={x=self.x-bbx, y=self.y-bby}
        --[[self.map:moveCamera(
            player.x, player.y, mscale or 3,
            self.map.slowCount
        )]]
        return true
end

function Bullet:ignore(item)
    return item.isMini or item.isPuff or item.isFloor
end

function Bullet.checkCollision(item, other)
    if not item.attackAll and other.isTile and not item.parent.breakBlocks and other.parent and other.parent.team==item.parent.team then
        return nil
    end
    
    if other.isTile and not other.isBackground then
        return item.collisionType
    end
    
    if other.isBullet then
        return "bounce"
    end
    
    if other == item.parent then--and item.ignoresParent then
        return nil
    elseif other.isBullet or other.isFire then
        return nil
    elseif other.isPuff then
        return nil
    elseif not other.isBackground and not item:ignore(other) then
        return item.collisionType
    end


end

function Bullet:destroy()
    Entity.destroy(self)
end

function Bullet:passiveDestroy()
    Entity.destroy(self)
end

function Bullet:move(x,y,dt)
    self.die = false
    self.life = self.life - dt
    if self.life<=0 then
        self.die = true
    end
    
    
    if not self.active then
        return 0,0
    end
    local actualX, actualY, collisions, len = self.world:move(self,x,y,
    self.checkCollision)
    local cc
    
    if math.abs(self._oldx - self.x) > self.w*2 or math.abs(self._oldy-self.y) > self.h*2 then
        self._oldx, self._oldy = self.x, self.y
    end
    
    for u = 1,len do
        cc = collisions[u]

        Entity.resolveCollision(self,cc)
        --[[Spark:new({
       -- x=cc.touch.x,y=cc.touch.y,
       time=(tt or .5),
       -#_h=t_h,_w=t_w,
        ssource = "players/gunSpark.png",
        x=actualX,y=actualY,map=self.map})
        ]]
        
        if cc.other.life>0 and not self.die then
            for i = 1, self.hits do
                cc.other:getAttacked(self)
                self.hits = self.hits-1
                if not cc.other.isTile then
                    cc.other:applyImpulse(self.vx/2, self.vy/2)
                    --self.map.camera:shakeObject(cc.other,10,.1)
                end
                if cc.other.life <=0 then
                    if cc.other.isTile then
                       -- cc.other:destroy()
                    end
                    break
                end
                if self.isBouncyBullet then
                    break
                end
            end
        end

        --die if hit to many things
        if self.hits<=0 then
            self.die = true
        end

    end
    
    if self.die then
        self:destroy()
    end
    
    return actualX, actualY
end

--todo: draw trail
function Bullet:draw()

    local v = game:getSource(self.source)
    local xx,yy,xxy,yyy = 0,0,v:getWidth()/2, v:getHeight()/2
    
    local ca = math.pi^2
    
    local h = self.parent and self.parent.h/2 or 0
    if self.parent and self.parent.flipX == -1 then xx = -self.parent.w/2 end
    
    local r,g,b,a = love.graphics.getColor()
    love.graphics.setColor(1,1,1,.5)
    
    if self.isBouncyBullet then
        local pn = love.graphics.getLineWidth()
        love.graphics.setLineWidth(self.w/2)
        local ww, hh = self.w/2, self.h/2
        love.graphics.line(self._oldx+ww, self._oldy+hh, self.x+ww, self.y+hh)
        love.graphics.setLineWidth(pn)
        love.graphics.setColor(r,g,b,a)
        love.graphics.draw(v,self.x,self.y,0,self._w,self._h)
        return
    end
    
    love.graphics.line(self._oldx+(self.w/1.5)+xx,self._oldy+h,self.x+xx+self.w/1.5,self.y+h)
    
    love.graphics.setColor(r,g,b,a)
    
    
    love.graphics.draw(v,self.x+(self.w/1.5)+xx,self.y+h,-(self.angle),
    self._w,self._h,0,yyy)

    
end
return Bullet