local Hat = class:extend("Hat")
local lgDraw = love.graphics.draw

function Hat:__init__(kwargs)
    self.parent = kwargs.parent or kwargs[1] or kwargs
    if kwargs==self.parent then
       kwargs = {
            x=self.parent.x,y=self.parent.y,
            w=self.parent.w,h=self.parent.h,
            xOffset=self.parent.xOffset,
            yOffset=self.parent.yOffset,
            color=self.parent.hatColor,
            source=self.parent.hatSource
        }
    end
    
    self.w = kwargs.w or self.parent.w or 10
    self.h = kwargs.h or self.parent.h or 10
    self.x = self.parent.x or kwargs.x or 0
    self.y = self.parent.y or kwargs.y or 0
    self.source = kwargs.source or "hats/topHat.png"
    if kwargs.isPlayer then
        self.source = "hat.png"
    end
    self.xOffset = kwargs.xOffset or 0
    self.yOffset = kwargs.yOffset or -self.parent.h+2
    self._w, self._h = resizeImage(self.source,self.w,self.h)
    self.color = kwargs.color or "black"
    self.defaultColor = self.color
    self._w, self._h = resizeImage(self.source,self.w,self.h)
    self._baseH = self.h
    self._baseW = self.w

    
end

function Hat:calculate(dt,w,h)
    local kv = 0
    w,h = w or 1, h or 1
    local res = Player.res
    if self.parent.display then
        kv = 4*res
    end
    
    local the = 4*res
    self.h = (self._baseH*h)+self.parent._h*(36*res)--.64
    self.w = (self._baseW*w)+self.parent._w*(60*res)--.4
    self._w, self._h = resizeImage(self.source,self.w,self.h)
    self.yOffset=-((res*38)+kv)*self.parent._h
    self.xOffset=-((res*33)-the)*self.parent._w
end

function Hat:update(dt)
    self:calculate(dt)
    self.x = self.parent.x+self.xOffset-1
    self.y = self.parent.y+self.yOffset
    if self.parent.passive then
        self.y = self.y+(H()*0.0125)
    end
end

function Hat:draw(x,y,w,h)
    local r,g,b,a = love.graphics.getColor()
    local __w = w
    
    if w then
        self:calculate(0,w,h)
    end
    
    if x then
        x = x+self.xOffset
    end
    if y then
        y = y+self.yOffset
    end
    
    local x,y,w,h = x or self.x, y or self.y, w or 1, h or 1
    w, h = self.w*w, self.h*h
    
    local flX, w = self.parent.flipX,0
    if flX<0 then
        w = self.w
    end
    love.graphics.setColor(getColor(self.color))
    lgDraw(game:getSource(self.source),x+w,y,0,self._w*flX,self._h)
    
    love.graphics.setColor(r,g,b,a)
    
end

function Hat:setColor(color)
    self.color = color or self.defaultColor
end

function Hat:destroy()
end

return Hat