local Spark = class:extend("Spark")

function Spark:__init__(parent)
    self.parent = parent or error("No parent")
    self.map = self.parent.map
    self.x = self.parent.x
    self.y = self.parent.y
    self.w = nw or self.map.tileW or 10
    self.h = nh or self.map.tileH or 10
    self.source = game:getAsset((self.parent.ssource or "spark.png"))
    self.uuid = lume.uuid()
    
    self._w = self.parent._w
    self._h = self.parent._h
    if not self._w then
        self._w, self._h = resizeImage(self.source,self.w,self.h)
    end
    
    self.map:storeBullet(self)
    
    self.lived = 0
    self.lifeTime = parent.time or .01
    
    self.angle = self.parent.angle or 0
    self.ox = self.parent.ox or nil
    self.oy = self.parent.oy or nil
end

function Spark:update(dt)
    self.lived = self.lived+dt
    if self.lived>self.lifeTime then
        self:destroy()
    end
end

function Spark:destroy()
    self.map:kill(self)
end

function Spark:draw()
    love.graphics.draw(self.source, self.x, self.y, self.angle, self._w, self._h, self.ox, self.oy)
end

return Spark
    