res = 10
zoom = 2
size = 10


rect = {
    x = 0*res,
    y = love.graphics.getHeight()-(size*res),
    w = size*res,
    h = size*res,
    vy = 0,
    vx = 0,
}

gravity = size*30
gravityY = gravity
gravityX = gravity

love.window.setMode(1,2)

function getDir(d)
    return (d<0 and -1) or (d>0 and 1) or 0
end

function applyImpulseY(d)
    rect.vy = -450*d
end

function applyImpulseX(d)
    rect.vx = 450*d
end


function drawRect()
    love.graphics.rectangle("line",rect.x,rect.y,rect.w,rect.h)
end

function updateRect(dt)
    --rect.vy = rect.vy + gravityY*dt
    rect.vx = rect.vx - gravityX*dt
    rect.y =  rect.y  + rect.vy*dt
    rect.x = rect.x + rect.vx*dt
    
    if rect.vx ~= 0 then
        gravityX = getDir(rect.vx)*gravity
    end
    
    if rect.vy ~= 0 then
        gravityY = getDir(rect.vy)*gravity
    end
end

function love.update(dt)
    updateRect(dt)
end

function love.draw()
    drawRect()
end

function love.mousereleased(x,y)
    --applyImpulseY(getDir(rect.y-y))
    applyImpulseX(getDir(rect.x-x)*-1)
end