Menu = class:extend("Menu")

function Menu:__init__(kwargs)
    
    self.data = kwargs.data or {}
    self.map = kwargs.map or {}
    
    self._onRelease = kwargs.onRelease or {}
    
    self.listbox = lume.copy(listbox)
    self.listbox:init()
    
    
    local w = kwargs.w or 100
    kwargs.x = W()/2-(w/2)
    
    local h = kwargs.h or 100
    local bh = ( (kwargs.h and kwargs.h/5) or 10)+20
    
    kwargs.y = H()/2-h/2
    
    
    kwargs.h = kwargs.h or 100
    local lh = kwargs.h-bh
    
    local ly = (kwargs.y or 100)
    local by = (kwargs.y or 100)+lh

    self.prompt = gooi.newPanel({
        x=kwargs.x or 0,
        y=by,
        h=bh,
        w=kwargs.w or 100,
        layout="grid 2x1"
    }):add(
        gooi.newButton({text="PLAY AGAIN"}):
            onRelease(function(r)
                mainMenu.drawProgress = nil
                game:startNewGame(nil,true)
            end),
        gooi.newButton({text="EXIT"}):
            onRelease(function(r)
                self.map:destroy(true)
                mainMenu.drawProgress = nil
                GSS(mainMenu)
            end)
    ):setStyle({font=font13})
    
    
    self._data = {
        x = kwargs.x or 0,
        y = ly,
        w = kwargs.w or 100,
        h = lh,
        istouch = true,
        visible = true,
        incenter = false,
        enabled = true,
        selectedcolor = game:getColor("red"),
        font = font13
    }
    
    self.listbox:newprop(self._data)
    
    self.add=function(...) self.listbox:additem(...) end
end

function Menu:load()
    if not self.map.isClient then
        for _,n in lume.iter(self.map:getScores()) do
            --self.add(
            n:getAchievement()
            --)
        end
    end
    
    self.listbox:setselected(1)
    self.oldSelected = self:getSelectedText()
    
end

function Menu:draw()
    self.listbox:draw()
    gooi.draw()
end

function Menu:destroy()
    self.listbox:setenabled(false)
    self.listbox:setvisible(false)
    gooi.removeComponent(self.prompt)
end

function Menu:create()
    gooi.removeComponent(self.prompt)
    self.listbox:setenabled(true)
    self.listbox:setvisible(true)
    gooi.addComponent(self.prompt)
end


function Menu:getSelectedText()
    return self.listbox:gettext(self.listbox:getselected())
end

function Menu:getSelectedData()
    return self.listbox:getdata(self.listbox:getselected())
end


function Menu:update(dt)
    self.listbox:update(dt)
    --gooi.update(dt)
end

function Menu:mousepressed(x,y,button)
    --gooi.pressed()
end

function Menu:mousereleased(x,y,button)
    --gooi.released()
end

function Menu:touchpressed(id, x, y, dx, dy, pressure)
    self.listbox:press(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end
end

function Menu:touchreleased(id, x, y, dx, dy, pressure)
    self.listbox:released(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end
end

return Menu