local function getDir(x,y)
    local xx,yy = 0,0
    if x>0 then xx=1 elseif x<0 then xx=-1 end
    if y>0 then yy=1 elseif y<0 then yy=-1 end
    return xx,yy
end

local function contains(tab, key)
    for x = 1,#tab do
        if key==tab[x] then
            return true
        end
    end
end

mainMenu = {}

local doMap = tryue
function mainMenu:init()
    self.current = "menu"
    self.oldCurrent = nil
    self.oldCurrents = {}
    self.camera = Camera()
    
    self.title = game:getAsset("full_title.png")
    local hh = H()/2
    y = (H()/2)-hh/2
    self.totalH = ((hh/3)+(H()-y-(hh)))+(hh/3)*2
    titleH = (hh/3)+(H()-y-(hh))
    self.titleH = titleH
    self.titleW, self.titleH = resizeImage(self.title,W()/2,(hh/3)+(H()-y-(hh)))--(((hh/3)*2)*2)))
    local vals = {-1,-.5,-.25,.25,.5,1}
    local ww, hh
    local f = math.floor
    local function change()
        local dirX, dirY = getDir(self.cameraMan.vx, self.cameraMan.vy)
        local sp = 500
        local x, y = dirX, dirY
        local fX, fY
        while (x==dirX and y==dirY) or (not fX or not self.map:getTile(f(fX/ww),f(fY/hh))) do
            x,y = lume.randomchoice(vals),lume.randomchoice(vals)
            local destX, destY = x*sp, y*sp 
            fX, fY = self.cameraMan.x+destX, self.cameraMan.y+destY
        end
        if nil then
            local t = lume.randomchoice(self.map.allTiles)
            x,y = t.x-self.cameraMan.x, t.y-self.cameraMan.y
            fX, fY = t.x, t.y
        end
        self.cameraMan.vx, self.cameraMan.vy = x,y
        self.cameraMan.animation = nil
        self.cameraMan.animation = Animation:new({x=fX, y=fY, d=math.abs(5*math.min(x,y))})
        self.cameraMan.animation:bind({onComplete=change})
        self.cameraMan.animation:start(self.cameraMan)
    end
    
    if doMap then
        --self.mapT = Timer.new()
        self.map = map or self.map or Underground:new({w = 100,h = 100})
        self.map:enter()
       -- self.map:update(0)
        local t = self.map.digger:getRandomTile(true)
        self.cameraMan = {x=t.x,y=t.y,vx=0,vy=0}
        ww,hh = t.w,t.h
        change()
    end
    

    self.menu = gooi.newPanel({
        w=W()/2, h=H()*.5,
        x=W()-((W()/2)/2)-W()/2,  y=(self.totalH-titleH)/2+(0+(H()*.5)/2),
        group="menu",
        layout="grid 3x3"
    }):
    setColspan(1,1,3):
    setColspan(2,1,3):
    add(
        gooi.newLabel({text="",group="menu",img=truue}),--:setIcon(game:getAsset("title.png")):center(),--Dust: Battle Beneath",group="menu"}):center(),
        gooi.newButton({text="PLAY",group="menu"}):
            onRelease(function(b)
                self.current = "load"
            end
            ),
        gooi.newButton({text="TRAINING",group="menu"}):
            onRelease(function()
                self.current = "train"
            end
            ),
        gooi.newButton({text="SETTINGS",group="menu"}):
            onRelease(function(b)
                self.current = "settings"
            end
            ),
        --[[gooi.newButton({text="HELP",group="menu"}):
            onRelease(function()
                self.current = "help"
            end
            ),]]
        gooi.newButton({text="EXIT",group="menu"}):
            onRelease(function()
                game:quit()
            end
            )
        
    )
        
    self.load = gooi.newPanel({
        w=W()/2, h=H()*.45,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="load",
        layout="grid 2x2"
    }):
    setColspan(1,1,2):
    add(
        gooi.newButton({text="Local Wifi",group="load"}):
            onRelease(function(b)
                self.current = "locall"
            end
            ),
        gooi.newButton({text="Online",group="load"}):
            onRelease(function()
                self.current = "online"
            end
            ),
        gooi.newButton({text="Back",group="load"}):
            onRelease(function()
                self.current = "menu"
            end
            )
        )
    
    
    self.locall = gooi.newPanel({
        w=W()/2, h=H()*.45,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="locall",
        layout="grid 2x2"
    }):
    setColspan(2,1,2):
    add(
        gooi.newButton({text="Join",group="locall"}):
            onRelease(function(b)
                self.current = "waitForHost"
                game:waitForHost()
            end
            ),
        gooi.newButton({text="Host",group="locall"}):
            onRelease(function()
                self.current = "host"
            end
            ),
        gooi.newButton({text="Back",group="locall"}):
            onRelease(function()
                self.current = "load"
            end
            )
        )
        
    self.waitForHost = gooi.newPanel({
        w=W()/2, h=H()*.45,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="waitForHost",
        layout="grid 2x1"
    }):
    add(
       gooi.newButton({text="searching...",group="waitForHost"}),
       gooi.newButton({text="Back",group="waitForHost"}):
            onRelease(function()
                --destroy client?
                self.current = "locall"
            end)
    )
        
               
    self.fogOfWar = true
    self.stealthInspection = false
    self.mapSize = "small"
    self.mapType = "random"
    self.bulletType = "Bullet"
    
    local mapSizes = {"size: small","size: medium", "size: large"}
    local mapTypes = {
        "type: random", "type: dungeon", "type: maze",
        "type: arena", "type: cave","type: none", "type: mine"
    }
    local bulletTypes = {}
    local txt = "Main Bullet: "--"Start with: "
    for x,bu in pairs(bullets) do
        table.insert(bulletTypes,string.format("%s%s Bullet",txt,bu.myName or "--"))
    end
    
    local function changeSize(n)
        local size = n:sub(7,-1)
        self.mapSize = size
    end
    
    local function changeMap(n)
        local type = n:sub(7,-1)
        self.mapType = type
    end
    
    local function changeBullet(b)
        local bullet = b:sub(#txt+1,-8)
        for x,i in pairs(bullets) do
            if i.myName == bullet then
                self.bulletType = x
                return
            end
        end
    end
    
    local function changeBots(b)
        local bot = b:sub(7,-1)
        self.bots = tonumber(bot)
    end
    
    self.bots = 0
    local botCounts = {"bots: 0","bots: 1","bots: 2","bots: 3"}
    
    local function startTutorial(b)
        local t = Tutorial:new({})
    end
    
    self.train = gooi.newPanel({
        w=W()/2, h=H()*.65,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="train",
        layout="grid 8x1"
    }):
    add(
        gooi.newButton({text="Train",group="train"}):
            onRelease(function()
                --self.current = "wait"
                --gooi.alert({text="!"})
                self.training = true
                game:startTraining()
            end),
            
        gooi.newCheck({text="fog of war",group="train",checked=true}):
            onRelease(function(n)
                self.fogOfWar = n
            end),
        gooi.newChooser({group="train",items=mapSizes}):
            onRelease(changeSize),
        gooi.newChooser({group="train",items=mapTypes}):
            onRelease(changeMap),
        gooi.newChooser({group="train",items=bulletTypes}):
            onRelease(changeBullet):
            setItem(string.format("%s%s Bullet",txt, Bullet.myName)),
        --[[gooi.newCheck({text="stealth inspection",group="train",checked=false}):
            onRelease(function(n)
                self.stealthInspection = n
            end),]]
        gooi.newChooser({group="train",items=botCounts}):
            onRelease(changeBots),
        gooi.newButton({text="Tutorial",group="train"}):
            onRelease(startTutorial),

        gooi.newButton({text="Back",group="train"}):
            onRelease(function()
                self.current = "menu"
            end
            )
        
    )
    
    self.waiting = gooi.newPanel({
        w=W()/4, h=H()-10,
        x=10, y=0,
        group="wait",
        layout="grid "..(MAX_PLAYERS+2).."x1"
    }):add(
        gooi.newButton({text="START",group="wait"}):
            onRelease(function()
                if game.host then
                    self.peer:sendToAll("startMatch")
                    self.peer:update(0)
                    game:startNewGame()
                else
              --      gooi.alert({text="Only the host can start the game!",group="wait"})
                end
            end)
    )
    self.wait = self.waiting
    self.waitButtons = {}
    
    local dText = "..."
    
    local teams = {"red","blue","green","yellow"}
    self.styles = {}
    for x, col in ipairs(teams) do
        self.styles[col] = {
            bgColor = getColor(col)
        }
    end
    
    local find = lume.find
    local changeTeam = function(b)
        if not game.host then
            return
        end
        
        if self.match~="team deathmatch" and self.match~="capture the flag" then
            return
        end
        if b.text~=dText then
            local team = find(teams, game.players[b.pIndex].team)
            if not team then team = 0 end
            if team == 4 then
                team = 0
            end
            team = team+1
            team = teams[team]
            b.team = team
            game.players[b.pIndex]:changeTeamTo(team)
            game.host:sendToAll("do",{"changeTeamTo",team,nil,nil,nil,b.pIndex})
            
        end
    end
            
    for x = 1, MAX_PLAYERS do
        self.waitButtons[x] = gooi.newButton({group="wait",text="..."}):
            onRelease(changeTeam)
        if self.match=="team deathmatch" or self.match=="capture the flag" then
            self.waitButtons[x]:setStyle(self.styles.blue)
        end
        
        self.waitButtons[x].pIndex = x
            
        self.waiting:add(self.waitButtons[x])
    end
    self.waiting:add(
        gooi.newButton({text="Back",group="wait"}):
            onRelease(function()
                if game.host then
                    game.host:destroy()
                    game.host = nil
                    self.peer = nil
                end
                game.player = nil
                game.players = {}
                game.map = nil
                self.peer = nil
                self.current = "locall"
            end)
    )
    
    self.hostWait = gooi.newPanel({
        w=W()/4, h=H()-10,
        x=10, y=0,
        group="hwait",
        layout="grid 2x1"
    }):add(
        gooi.newLabel({group="hwait",text="Searching..."}),
        gooi.newButton({group="hwait",text="Back"}):
            onRelease(function()
                game.client = nil
                self.peer = nil
                self.current = "locall"
                game.map = nil
            end)
        )
    
    
    self.time = 5*60
    self.match = "deathmatch"
    
    local times = {2,5,10,15}
    local toTimes = {}
    local str = "Time: %s min"
    for x, i in ipairs(times) do
        local s = string.format(str, i)
        times[x] = s
        toTimes[s] = i
    end
    
    local function changeTime(b)
        local t = toTimes[b]
        self.time = t*60
    end
    
    local gameTypes = {"deathmatch","king pin","team deathmatch"}
    local str = "Game Type: %s"
    for x, i in ipairs(gameTypes) do
        gameTypes[x] = string.format(str,i)
    end
    
    local function changeMatch(b)
        local m = b:sub(12,-1) log(m)
        self.match = m
    end
    
    self.host = gooi.newPanel({
        w=W()/1.5, h=H(),
        x=W()-((W()/1.5)/2)-W()/2, y=0,
        group="host",
        layout="grid 8x1"
    }):
    --setColspan(1,1,2):
    --setColspan(2,1,2):
    --setColspan(5,1,2):
    --setColspan(9,1,2):
    add(
        gooi.newButton({text="Host",group="host"}):
            onRelease(function()
                self.current = "wait"
                for x = 1,MAX_PLAYERS do
                    if self.match=="team deathmatch" or self.match=="capture the flag" then
                        self.waitButtons[x]:setStyle(self.styles.blue)
                    else
                        self.waitButtons[x]:setStyle(dustStyle)
                    end
                end
                game:waitForPlayers()--startNewGame()
            end),
        
        gooi.newChooser({items=gameTypes,group="host"}):
            onRelease(changeMatch),
        gooi.newChooser({items=times,group="host"}):
            onRelease(changeTime),
            
        gooi.newCheck({text="fog of war",group="host",checked=true}):
            onRelease(function(n)
                self.fogOfWar = n
            end),
    
        gooi.newChooser({group="host",items=mapSizes}):
            onRelease(changeSize),
        gooi.newChooser({group="host",items=mapTypes}):
            onRelease(changeMap),
        gooi.newChooser({group="train",items=bulletTypes}):
            onRelease(changeBullet):
            setItem(string.format("%s%s Bullet",txt, Bullet.myName)),
        gooi.newButton({text="Back",group="host"}):
            onRelease(function()
                self.current = "locall"
            end
            )
        
    )
    
    self.help = HelpMenu:new({group="help"})
    self.online = OnlineMenu:new({})
    self.settings = SettingsMenu:new({group="settings",parent=self})
    self._current = self.menu
        
    self.menus = {
        load = self.load,
        menu = self.menu,
        locall = self.locall,
        hwait = self.hostWait,
        host = self.host,
        join = self.join,
        wait = self.waiting,
        settings = self.settings,
        help = self.help,
        train = self.train,
        online = self.online,
        waitForHost = self.waitForHost
    }
    self.tiles = {}
    local s = game:getAsset("tiles/dirt.png")
    local tw,th = resizeImage(s,W()/10,W()/10)
    for x = 1,10 do
        for y = 1,10 do
            t = {s}
            t.w, t.h = W()/10,W()/10
            t.x = (x-1)*t.w
            t.y = (y-1)*t.h
            t._w, t._h = tw,th
            self.tiles[#self.tiles+1] = t
        end
    end
    self.totalTiles = #self.tiles
end


function mainMenu:update(dt)
    local trash = self._current.update and self._current:update(dt) or gooi.update(dt)
   
   --don't update peer so that not missing tile error happens until map finishes loading
    if self.peer and (game.host==self.peer or (not self.drawProgress)) then--and not self.peer.pause then
        self.peer:update(dt)
    end
    
    if self.drawProgress then
        if game.copaused then --log("st")
            game.copaused = nil
            coroutine.resume(game.co)
            return
        end
    end
    

    if doMap then
        self.map.camera:update(dt)
        self.cameraMan.animation:update(dt)
        self.map.camera:follow(self.cameraMan.x, self.cameraMan.y)
        local t = self.map:getTile(
            self.map:convertPixelToTile(self.cameraMan.x,self.cameraMan.y))
  --      t:destroy(true)
    end
    
    if self.oldCurrent ~= self.current then
        if self.current=="new" then ggr=4 end--??
        for i,n in lume.iter(self.menus) do
            local trash = n.destroy and n:destroy()
            gooi.removeComponent(n)--self.menus[self.current])
        end
        gooi.pressed() gooi.released()
        local m = self.menus[self.current]
        
        self._current = self.menus[self.current]
        if not m then
            log("Tried something!! Current failed at menu "..self.current)
            self.current = "menu"
            self._current = self.menus[self.current]
            return
        end
        
        local trash = m.create and m:create()
        gooi.currentGroup = self._current.group
        if m.img3D then
            gooi.addComponent(m.__class and m.info or m)
        end
        if self.oldCurrent and not self.ignoreOld then
            if (not contains(self.oldCurrents, self.oldCurrent)) then
                table.insert(self.oldCurrents,self.oldCurrent)
            end
        elseif self.ignoreOld then
            self.ignoreOld = false
        end
        
        self.oldCurrent = self.current
    end
    self._current = self.menus[self.current]
       
end


function mainMenu:enter()
   -- self:init()
end

function mainMenu:resume()
  --  self:init()
end

function mainMenu:destroy()
    gooi.removeComponent(self._current)
    gooi.currentGroup = nil
end

function mainMenu:create(menu)
    menu = menu or self._current
    if type(menu)=="string" then
        menu = self.menus[menu]
    end
    gooi.addComponent(menu)
    self.oldCurrent = "none"
end

function mainMenu:draw()
    local sc = self.camera.scale
    --self.camera.scale = sc*getRatio()
    self.camera:attach()
    
    local yh = (self.totalH-self.titleH)/2+(0+(H()*.5)/2)
    if doMap then
        self.map:draw()
    end
    for i = 1,self.totalTiles do
        local t = self.tiles[i]
        love.graphics.draw(t[1],t.x,t.y,0,t._w,t._h)
    end
    love.graphics.draw(self.title,W()/2-W()/4,
   0+(H()/2)/3,-- self.menu.y,--(self.totalH-(((H()/2)/3)*2))/2,
    0,--H()*.5-(0+(H()*.55)/2),0,
    --H()/2-self.title:getHeight()/2)--
    self.titleW,self.titleH)
    
    local trash = self._current.draw and self._current:draw() or
        gooi.draw(self.current)
--    gooi.draw()

    if self.drawProgress then
        game.progress:draw()
    end
    
    self.camera:detach()
    self.camera.scale=sc
    if dtrack then ProFi:stop() ProFi:writeReport("udraw.txt") error(tt) end

end

function mainMenu:setProgress(n)
    local p = game.progress
    p:setProgress(n)
end

function mainMenu:progress(n)
    if not self.drawProgress then
        self.drawProgress = true
        self:setProgress(0)
    end
    local p = game.progress
    p:progress(n or 0)
    if game.co then
        --coroutine.resume(game.co)
    end
end

function mainMenu:stopProgress()
    self.drawProgress = false
end

function mainMenu:leave()
    for i,n in lume.iter(self.menus) do
        local trash = n.destroy and n:destroy()
        gooi.removeComponent(n)--self.menus[self.current])
    end
end

function mainMenu:mousereleased() gooi.released() end
function mainMenu:mousepressed()  gooi.pressed() end

function mainMenu:touchreleased(id, x, y, dx, dy, pressure)
    if not self.buttonPressed then
        ttx = x
        tty = y
    end
    self.buttonPressed = false
    local trash = self._current.touchreleased and 
        self._current:touchreleased(id,x,y,dx,dy,pressure)
end

function mainMenu:touchpressed(id, x, y, dx, dy, pressure)

    local trash = self._current.touchpressed and 
        self._current:touchpressed(id,x,y,dx,dy,pressure)
    end
function mainMenu:textinput(text)
  gooi.textinput(text)
end

function mainMenu:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
      if #self.oldCurrents>0 then
        self.current = table.remove(self.oldCurrents,#self.oldCurrents)
        log(self.current.." Switching to table menu "..inspect(self.oldCurrents,3))
        self.ignoreOld = true
      else
        game:close()
      end
  end
end

function mainMenu:keyreleased(key, scancode) log(key) log("kr")
  gooi.keyreleased(key, scancode)
end


return mainMenu