Menu = class:extend("Menu")

function Menu:__init__(kwargs)
    
    self.data = kwargs.data or {}
    self.map = kwargs.map or {}
    
    self._onRelease = kwargs.onRelease or {}
    
    self.listbox = lume.copy(listbox)
    self.listbox:init()
    
    self.hostName    = gooi.newButton({text="..."})
    self.mapType     = gooi.newLabel({text="..."})
    self.matchTime   = gooi.newLabel({text="..."})
    self.matchType   = gooi.newLabel({text="..."})
    self.fogOfWar    = gooi.newLabel({text="..."})
    self.bulletType  = gooi.newLabel({text="..."})
    
    self.list = gooi.newPanel({
        x=0,
        y=0,
        h=H(),
        w=W()/3,
        layout="grid 13x1",
        group="online"
    }):add(
        gooi.newButton({text="JOIN"}):
        onRelease(function(b)
        
        end),
        
        self.hostName,
        
        gooi.newButton({text="Map Type"}),
        self.mapType,
        
        gooi.newButton({text="Match Type"}),
        self.matchType,
        
        gooi.newButton({text="Match Time"}),
        self.matchTime,
        
        gooi.newButton({text="Fog of War"}),
        self.fogOfWar,
        
        gooi.newButton({text="Main Bullet"}),
        self.bulletType,
        
        gooi.newButton({text="Back"}):
        onRelease(function()
            mainMenu.current = "load"
        end)
    )
    
    
    self._data = {
        x = W()/3,
        y = 0,
        w = (W()/3)*2,
        h = H(),
        istouch = true,
        visible = true,
        incenter = false,
        enabled = true,
        selectedcolor = game:getColor("red"),
        bordercolor = getColor("chocolate"),
        bgcolor = getColor("darkbrown",.5)
    }
    

    self.listbox:newprop(self._data)
    
    self.add=function(...) self.listbox:additem(...) end
    
    
    self.client = online.client:new()
    self:reload()
    
end

function Menu:reload()
    self.client:reload()
    
    self.hosts = {}
    self.connected = 0
    
    local data = "..."
    
    self.hostName:setText(data)
    self.mapType:setText(data)
    self.matchTime:setText(data)
    self.matchType:setText(data)
    self.fogOfWar:setText(data)
    self.bulletType:setText(data)
    
    self.listbox:setselected(1)
    self.oldSelected = self:getSelectedText()
    self:changeViewTo(self.oldSelected)
end

function Menu:changeViewTo(host)
    if not host then
        return
    end
    
    local data = self.hosts[host]
    if not data then
        return
    end
    
    self.hostName:setText(data.name)
    self.mapType:setText(data.mapType)
    self.matchTime:setText(data.matchTime)
    self.matchType:setText(data.matchType)
    self.fogOfWar:setText(data.fogOfWar)
    self.bulletType:setText(data.bulletType)
end

function Menu:draw()
    self.listbox:draw()
    gooi.draw("online")
end

function Menu:destroy()
    self.listbox:setenabled(false)
    self.listbox:setvisible(false)
    gooi.removeComponent(self.list)
end

function Menu:create()
    gooi.removeComponent(self.list)
    self.listbox:setenabled(true)
    self.listbox:setvisible(true)
    gooi.addComponent(self.list)
end


function Menu:getSelectedText()
    return self.listbox:gettext(self.listbox:getselected())
end

function Menu:getSelectedData()
    return self.listbox:getdata(self.listbox:getselected())
end

function Menu:addNewHost(hostData)

    local name = hostData.name
    if self.hosts[name] then
        local count = 1
        while self.hosts[name] do
            name = name.."("..count..")"
            count = count+1
        end
    end
    
    hostData.name = name
    self.hosts[name] = hostData
    self.add(name)
end

function Menu:update(dt)
    self.listbox:update(dt)
    self.client:update(dt)
    
    local connected = self.client.confirmedMatches
    if #connected>self.connected then
        self.connected = #connected
        self:addNewHost(connected[#connected])
        
    elseif #connected<self.connected then
        --wha, how?
        error("Lost connection?")
    end


    local t = self:getSelectedText()
    if t ~= self.oldSelected then
        self:changeViewTo(t)
        self.oldSelected = t
    end
    --gooi.update(dt)

end

function Menu:mousepressed(x,y,button)
    --gooi.pressed()
end

function Menu:mousereleased(x,y,button)
    --gooi.released()
end

function Menu:touchpressed(id, x, y, dx, dy, pressure)
    self.listbox:press(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end
end

function Menu:touchreleased(id, x, y, dx, dy, pressure)
    self.listbox:released(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end
end

return Menu