Menu = class:extend("Menu")

function Menu:__init__(kwargs)
    
    self.data = kwargs.data or {}
    self.map = kwargs.map or {}
    
    self._onRelease = kwargs.onRelease or {}
    
    self.listbox = lume.copy(listbox)
    self.listbox:init()
    
    
    local w = kwargs.w or 100
    kwargs.x = W()/2-(w/2)
    
    local h = kwargs.h or 100
    local bh = ( (kwargs.h and kwargs.h/5) or 10)+20
    
    kwargs.y = H()/2-h/2
    
    
    kwargs.h = kwargs.h or 100
    local lh = kwargs.h-bh
    
    local ly = (kwargs.y or 100)
    local by = (kwargs.y or 100)+lh

    self.back = gooi.newButton({
        x=kwargs.x or 0,
        y=by,
        h=bh/2,
        w=kwargs.w or 100,
        text="<BACK"
    }):onRelease(function(r)
        self.map:unpause()
    end)
    
    self.exit = gooi.newButton({
        x=kwargs.x or 0,
        y=by+bh/2,
        h=bh/2,
        w=kwargs.w or 100,
        text="Exit"
    }):onRelease(function()
        self.map.exiting = true
        gooi.confirm({
        text = "Are you sure?",
        ok = function(r)
            self.map:unpause()
            if self.map:hasPeer() then
                if game.host then
                    game.host:destroy()
                end
            end
        
            self.map:destroy()
            mainMenu:create("menu")
            GSS(mainMenu)
        end})
        
    end)
    
    local respawnText = ""
    if self.map.respawnTime then
        self.playerDied = true
  --      respawnText = self.map:getRespawnTime()
    end
    
    self.respawn = gooi.newLabel({
        text=respawnText,
        y=by-bh/2,
        x=(kwargs.x+(kwargs.w or 100))-W(12),
        h=bh/2
    }) --self.map.player.life=1
    
    local font = font13
    local fontStyle = {font=font13}
    
    self._data = {
        x = kwargs.x or 0,
        y = ly,
        w = kwargs.w or 100,
        h = lh,
        istouch = true,
        visible = true,
        incenter = false,
        enabled = true,
        selectedcolor = game:getColor("red"),
        bgcolor = game:getColor("darkbrown",.5),
        font = font
    }
    
    self._text = gooi.newText({text=""})
    self.messager = gooi.newPanel({
    layout="grid 1x5",w=W(),h=H()/10,y=0,x=0}):
        setColspan(1,1,4):
        
        add(
            self._text,
            gooi.newButton({text="Submit",icon=game:getSource("star.png")}):
            onRelease(function()
                self.map:sendMessage(self._text:getText())
                
                ---remove in release---????
                _G["self"] = self.map
                
                l,e = loadstring(self._text:getText())
                if e then
                    log(e)
                end
                if l then
                    local n,e = l()--pcall(l)
                    if not n then
                 --       log(e)
                    end
                end
                
                local s = self
                _G["self"] = nil
                local self = s
                ---remove end---
                
                self._text:setText("")
                assert(self._text:getText()=="")
            end)--:setStyle(fontStyle)
        ):
        setStyle(fontStyle)
    self._text:setStyle({font=font8})
    
    self.listbox:newprop(self._data)
    
    self.add=function(...) self.listbox:additem(...) end
    
    for _,n in lume.iter(self.map:getScores()) do
        self.add(n:printScore())
    end
    
    self.listbox:setselected(1)
    self.oldSelected = self:getSelectedText()
    
    
end

function Menu:draw()
    self.listbox:draw()
    gooi.draw()
end

function Menu:destroy()
    self.map.exiting = false
    self.listbox:setenabled(false)
    self.listbox:setvisible(false)
    gooi.removeComponent(self.back)
    gooi.removeComponent(self.exit)
    gooi.removeComponent(self.messager)
    gooi.removeComponent(self.respawn) assert(not self._text.enabled)
end

function Menu:create()
    gooi.removeComponent(self.back)
    gooi.removeComponent(self.messager)
    gooi.removeComponent(self.respawn)
    self.listbox:setenabled(true)
    self.listbox:setvisible(true)
    gooi.addComponent(self.back)
    gooi.addComponent(self.exit)
    gooi.addComponent(self.messager)
    gooi.addComponent(self.respawn)
end


function Menu:getSelectedText()
    return self.listbox:gettext(self.listbox:getselected())
end

function Menu:getSelectedData()
    return self.listbox:getdata(self.listbox:getselected())
end


function Menu:update(dt)
    self.listbox:update(dt)
    if self.map.respawnTime then
        self.respawn:setText(self.map:getRespawnTime())
    end
    if self.playerDied then
        if not self.map.player.dead then
            self.map:unpause()
        end
    end
    --gooi.update(dt)
end

function Menu:mousepressed(x,y,button)
    --gooi.pressed()
end

function Menu:mousereleased(x,y,button)
    --gooi.released()
end

function Menu:touchpressed(id, x, y, dx, dy, pressure)
    self.listbox:press(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end
end

function Menu:touchreleased(id, x, y, dx, dy, pressure)
    self.listbox:released(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end
end

return Menu