local Menu = class:extend("Menu")

local width = W()/3

function Menu:__init__(kwargs)

    self.data = kwargs.data or {}
    self.group = kwargs.group
    self.parent = kwargs.parent
    self.timer = Chrono()
    
    local currentC
    self.colorGrid = gooi.newPanel({
        x=width,y=H()-(H()/2),
        h=H()/2,w=width*2,
        group=self.group,
        layout = "grid 5x13"
    })
    --error(#playerColors)
    local function changeColor(b)
        local col = b.info
        if not currentC then
            game.settings.color = col
        elseif currentC == "stomach" then
            game.settings.stomachColor = col
        elseif currentC == "gun" then
            game.settings.gunColor = col
        elseif currentC == "hat" then
            game.settings.hatColor = col
        elseif currentC == "hat2" then
            game.settings.hat2Color = col
        end
        self.displayPlayer:reload()
    end
    
    for x = 1, #playerColors do
        color = playerColors[x]
        self.colorGrid:add(
            gooi.newButton({
                text="",group=self.group,
                info=color
            }):setStyle({bgColor=getColor(color)}):
            onRelease(changeColor)
        )
    end
    gooi.removeComponent(self.colorGrid)
    
    
    local theHats = {}
    local function changeHat(b)
        game.settings.hat = theHats[b:sub(6,-1)]
        self.displayPlayer:reload()
        if currentC~="hat" then
            gooi.removeComponent(self.colorGrid)
        end
    end
    
    local function changeHat2(b)
        game.settings.hat2 = theHats[b:sub(7,-1)]
        self.displayPlayer:reload()
        if currentC~="hat2" then
            gooi.removeComponent(self.colorGrid)
        end
    end
    
    local function changeHatOlo(b)
        game.settings.hat = b
        self.displayPlayer:reload()
    end
    
    local allHats, allHats2 = {}, {}
    local str1 = "Hat: %s"
    local str2 = "Hat2: %s"
    local count = 1
    for x in pairs(hats) do
        theHats[tostring(count)] = x
        table.insert(allHats,string.format(str1,count))
        table.insert(allHats2,string.format(str2,count))
        count = count+1
    end

    self.hatChooser = gooi.newChooser({group=self.group,items=allHats,drawNumber=false}):
        onRelease(changeHat)
    self.hat2Chooser = gooi.newChooser({group=self.group,items=allHats2,drawNumber=false}):
        onRelease(changeHat2)
    
    local count = 15
    if DESKTOP then
    count = count + 2
    self.options = gooi.newPanel({
        x=0,y=0,
        h=H(),w=width,
        group=self.group,
        layout = string.format("grid %sx1",count)
    }):add(
        gooi.newButton({text="Name",group=self.group}),
        gooi.newText({group=self.group}):setText(game.settings.name):
        onText(function(val)
            game.settings.name = val
        end),
        gooi.newButton({text="Music",group=self.group}),
        gooi.newSpinner({min=0,max=10,value=game.settings.music,group=self.group}):
        onRelease(function(val,r)
            game.settings.music = r.value
            media.setVolume(game.settings.music)
        end),
        gooi.newButton({text="SFX",group=self.group}),
        gooi.newSpinner({min=0,max=10,value=game.settings.sfx,group=self.group}):
        onRelease(function(val,r)
            game.settings.sfx = r.value
            media.setSFXVolume(game.settings.sfx)
            media.sfx.player_jumped:play()
        end),
        gooi.newCheck({text="Raw textured dirt",selected=game.settings.raw}):
        onRelease(function(nn)
            game.settings.raw = nn
        end),
        gooi.newButton({text="Color",group=self.group}):
        onRelease(function()
            if currentC ~= nil then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = nil
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        gooi.newButton({text="Stomach Color",group=self.group}):
        onRelease(function()
            if currentC ~= "stomach" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "stomach"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        gooi.newButton({text="Gun Color",group=self.group}):
        onRelease(function()
            if currentC ~= "gun" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "gun"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        self.hatChooser,
        gooi.newButton({text="Hat Color",group=self.group}):
        onRelease(function()
            if currentC ~= "hat" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "hat"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        self.hat2Chooser,
        gooi.newButton({text="Hat2 Color",group=self.group}):
        onRelease(function()
            if currentC ~= "hat2" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "hat2"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
            gooi.newButton({text="Controls...",group=self.group}):
            onRelease(function()
                GSS(Config())--game.configScreen)
            end),
            gooi.newCheck({text="Mouse shoots",selected=game.settings.mouse_shoots}):
            onRelease(function(nn)
                game.settings.mouse_shoots = nn
            end),
        gooi.newButton({text="Back",group=self.group}):
        onRelease(function()
            self.parent.current = "menu"
        end)
    )
    
    
    
    
    
    else
    
    self.options = gooi.newPanel({
        x=0,y=0,
        h=H(),w=width,
        group=self.group,
        layout = string.format("grid %sx1",count)
    }):add(
        gooi.newButton({text="Name",group=self.group}),
        gooi.newText({group=self.group}):setText(game.settings.name):
        onText(function(val)
            game.settings.name = val
        end),
        gooi.newButton({text="Music",group=self.group}),
        gooi.newSpinner({min=0,max=10,value=game.settings.music,group=self.group}):
        onRelease(function(val,r)
            game.settings.music = r.value
            media.setVolume(game.settings.music)
        end),
        gooi.newButton({text="SFX",group=self.group}),
        gooi.newSpinner({min=0,max=10,value=game.settings.sfx,group=self.group}):
        onRelease(function(val,r)
            game.settings.sfx = r.value
            media.setSFXVolume(game.settings.sfx)
            media.sfx.player_jumped:play()
        end),
        gooi.newCheck({text="Raw textured dirt",selected=game.settings.raw}):
        onRelease(function(nn)
            game.settings.raw = nn
        end),
        gooi.newButton({text="Color",group=self.group}):
        onRelease(function()
            if currentC ~= nil then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = nil
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        gooi.newButton({text="Stomach Color",group=self.group}):
        onRelease(function()
            if currentC ~= "stomach" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "stomach"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        gooi.newButton({text="Gun Color",group=self.group}):
        onRelease(function()
            if currentC ~= "gun" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "gun"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        self.hatChooser,
        gooi.newButton({text="Hat Color",group=self.group}):
        onRelease(function()
            if currentC ~= "hat" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "hat"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        self.hat2Chooser,
        gooi.newButton({text="Hat2 Color",group=self.group}):
        onRelease(function()
            if currentC ~= "hat2" then
                gooi.removeComponent(self.colorGrid)
            end
            currentC = "hat2"
            if not gooi.removeComponent(self.colorGrid) then
                gooi.addComponent(self.colorGrid)
            end
        end),
        
        gooi.newButton({text="Back",group=self.group}):
        onRelease(function()
            self.parent.current = "menu"
        end)
    )
    end

        
    self.displayPlayer = game:getPassivePlayer(width+(W()-width)/2,H()*.25,W()*.125,H()*.2)
    self.displayPlayer.display = true
    
end

local actions = {"stand","walk","run","gun","turn","feel"}
function Menu:getNewAction()
    local act = lume.randomchoice(actions)
    local pl = self.displayPlayer
    local time = {5,10}
    
    if act == "walk" then
        pl.sprite:switch("walking")
    elseif act == "stand" then
        pl.sprite:switch("standing")
    elseif act == "run" then
        pl.sprite:switch("running")
    elseif act == "turn" then
        pl.flipX = pl.flipX*-1
        pl.Rjoystick.angle = math.rad(math.deg(pl.Rjoystick.angle)*-1)
        time = {3,7}
    elseif act == "gun" then
        local time = math.random(3,5)
        local ang = math.rad(math.random(-80,80)*pl.flipX)
        self.timer:tween(time, pl.Rjoystick,{angle=ang})
        local angle = pl.Rjoystick.angle
      --[[  self.Rjoystick.angle = 0
                if math.deg(angle)>90 and math.deg(angle)<270 then
                    self.flipX = -1
                else--if math.deg(angle)<180 and math.deg(angle)>0 then
                    self.flipX = 1
                end]]
    elseif act == "feel" then
        pl:feelRandom()
        time = {2,3}
    end
    
    local function changeAct()
        self:getNewAction()
    end
    self.timer:after(time,changeAct)
end

function Menu:draw()
    self.displayPlayer:draw()
end

function Menu:destroy()
    gooi.removeComponent(self.options)
    gooi.removeComponent(self.colorGrid)
    self.active = false
end

function Menu:create()
    self.hatChooser:setItem(game.settings.hat)
    self.hat2Chooser:setItem(game.settings.hat2)
    
    gooi.removeComponent(self.options)
    gooi.addComponent(self.options)
    if not self.displayPlayer then
        self.displayPlayer = game:getPassivePlayer()
    end
    self:getNewAction()
end

function Menu:update(dt)
    --gooi.update(dt)
    self.timer:update(dt)
    self.displayPlayer:update(dt)
end

function Menu:mousepressued(x,y,button)
    gooi.pressed()
end

function Menu:mousereleasued(x,y,button)
    gooi.released()
end

function Menu:touchpressued(id, x, y, dx, dy, pressure)
    self.listbox:press(x,y)
end

function Menu:touchreleaused(id, x, y, dx, dy, pressure)
    self.listbox:released(x,y)
end

return Menu