local socket = require "socket"

local deserialize = bitser.loads
local serialize = bitser.dumps

local get_matches = null
local offer_match = nuĺl
local redact_match = null

local online = {}


--Client Side--
online.client = class:extend("Client")

function online.client:__init__()
    self:reload()
end

function online.client:reload()
    self.confirmedMatches = {}
    local ips = get_matches() or {}
    local port = GAME_PORT
    
    self.udp = socket.udp()
    local udp = self.udp
    
    udp:settimeout(0)
    
    for x, i in ipairs(ips) do
        udp:setpeername(i,port)
        udp:send("get data")
    end
end

function online.client:update(dt)
    local data, ip = self.udp:receivefrom()
    
    if data then
        --sort data
        local hostData = deserialize(data)
        self.confirmedMatches[#self.confirmedMatches+1] = hostData
        hostData = #self.confirmedMatches
    end
end


--Server Side--
online.host = class:extend("Host")

function online.host:__init__()
    self:load()
end

function online.host:load()
    offer_match()
    local port = GAME_PORT
    
    self.udp = socket.udp()
    local udp = self.udp
    
    udp:setsockname("*",port)
    udp:settimeout(0)
end

function online.host:update(dt)
    local data, ip = self.udp:recievefrom()
    if data == "get data" then
        local hostData = {
            name = game.settings.name,
            matchType = mainMenu.match,
            matchTime = mainMenu.time,
            mapType = mainMenu.mapType
        }
        self.udp:sendto(serialize(hostData),ip,port)
    end
end

function online.host:close()
    redact_match()
end

return online