Scene = class:extend("Scene")

function Scene:__init__(kwargs)
  --  Underground.__init__(self,kwargs)
    self.entities = {}
    self.bullets = {}
    self.turrets = {}
    self.gore = 1
    
    local gs = function(s) return game:getSource(s) end
    self.tileSources = {
        ["iron.png"] = gs("iron.png"),
        ["background_dirt.png"] = gs("background_dirt.png"),
        ["dirt.png"] = gs("dirt.png"),
        ["stone.png"] = gs("stone.png")
    }
    self.tile = {w=1,h=1}
    game.map = self
    self.world = bump.newWorld()
    self.floor = Entity:new({map=self,w=_W*2, h=H()/6, x=-W()/2, y=H()-(H()/6),vy=0,vx=0})
    self.floor.isFloor = true
    self.turret = Turret:new({
        map=self, w=16, h=16, x=(_W/6)+30, y=H()-(H()/6)-70,bullet="Bullet"
    })--sight=25000})
    self.turret.shootAt = function(self,target)
        local b = self.bullet:new({
            x = self.x,
            y = self.y,
            angle = self:getAngle(target),
            parent = self,
            map = self.map,
            target = target, delay=.3
        }) --warn()
        b.getTile = self.getTile
        b.attack= 90
   end
   
    self.turret.getTile = function(self) self.tile = 4 end
    
    self.player = Player:new({map=self,x=0,y=H()-(H()/6)-5})
    self.player.createPuff = function(self)
        local min = min or math.random(0,1)
        self.madePuff = 3
        if max then
            min = math.random(min, max)
        end
        for i = 1,min do
            Puff:new({map=self.map,
                x=self.x + self.w,
                y=self.y + self.h / 2,
                minSize=16 * (1 - math.random()),
                maxSize=39,
                vx=2, vy=3}
            )
            self.stats.dustProduced = self.stats.dustProduced+1
        end 
    end
    self.player.real= true
    self.hasPeer = null
    self.player.getAttacked = function(self)
        if not self.dead then
            self:die()
            self.map.timer=1.5
            self.map.dead=1
        end
    end
    game.players = {self.player}
    self.camera = Camera()
    self.camera.scale = 3
    self.timer = 3
    self.active = 4
    
    
	self.canvas = love.graphics.newCanvas(love.graphics.getDimensions( ))
    love.graphics.setCanvas(self.canvas)
    local size = 50
    self.tiles = {}
    local s = game:getAsset("tiles/background_dirt.png")
    local tt = game:getAsset("tiles/dirt.png")--self.tileSources["dirt.png"]
    local tw,th = resizeImage(s,W()/size,W()/size)
    for x = 1,size*2 do
        for y = 1,size do
            t = {s,tt}
            t.w, t.h = W()/size,W()/size
            t.x = (x-1)*t.w
            t.y = (y-1)*t.h
            t._w, t._h = tw,th
            self.tiles[#self.tiles+1] = t
            love.graphics.draw(t[1],t.x,t.y,0,t._w,t._h)
            love.graphics.draw(t[2],t.x+self.floor.x, t.y+self.floor.y, 0, t._w,t._h)
        end
    end
    self.totalTiles = 0--#self.tiles
    love.graphics.setCanvas()

    
end

function Scene:getTile()
end

function Scene:storeBullet(u)
    self.entities[u.uuid] = u
end

function Scene:playerDied()
end

function Scene:getTileP()
    return nil
end

function Scene:kill(u)
    self.entities[u.uuid] = nil
end

function Scene:update(dt)
  --  self.player.real = true
    self.player:changeVelocityByKeys(dt,1,0)
    self.player.vx = self.player.vx/5
    for x, i in pairs(self.entities) do
        if i~=self.floor then
            i:update(dt)
        end
    end
    self.turret.LASTi_SHOT = 0
  --  self.player:
    self.camera:follow(self.player.x, self.player.y)
    self.camera:update(dt)
    self.timer = self.timer-dt
    if self.timer<.5 and not self.dead then
        self.player:die()
        self.dead = 1
    end
    if self.timer<0 and self.dead then
        self:endScene()
    end
    if self.timer<=2.5 and not self.jumped then
        self.jumped = 1
        self.player:jump()
    end
end

function Scene:draw()
    self.camera:attach()
    self.player.real = false

    for i = 1,self.totalTiles do
        local t = self.tiles[i]
        love.graphics.draw(t[1],t.x,t.y,0,t._w,t._h)
        love.graphics.draw(t[2],t.x+self.floor.x, t.y+self.floor.y, 0, t._w,t._h)
        love.graphics.draw(t[2],t.x+self.floor.x, t.y+self.floor.y, 0, t._w,t._h)
    end
    love.graphics.draw(self.canvas,-W()/2,0)
    
    local r,g,b,a = love.graphics.getColor()
    love.graphics.setColor(getColor("woodbrown"))
  --  love.graphics.rectangle("fill",self.floor.x, self.floor.y, self.floor.w, self.floor.h)
    love.graphics.setColor(r,g,b,a)
    for x, i in pairs(self.entities) do
        if i~=self.floor then
            i:draw()
        end
    end
    self.camera:detach()
end

function Scene:endScene()
    game.map = nil
    game.players = {}
    splash = game.splash--plash:new()
    splash:reload()
    GSS(splash)
    
    local title = game:getSource("full_title.png")
    local tw, th = title:getDimensions()
    
    splash:addSplash(title,1,nil,resizeImage(title,(W()/_W)*tw,(H()/_H)*th))
    
    splash:onComplete(function()
        Gamestate.switch(mainMenu)
        if (game.settings.firstTime) then
            game.settings.firstTime = false
            if DESKTOP then
                bigc = true
                local next = "\n"
                local nexts = {"\n","======"}
                local count = 2
                local controls = ""
                for x, i in pairs(IM.KEYMAP) do
                    controls = controls..next.."==="..x..":"..i[1].."==="
                    next = nexts[count]
                    count = count +1
                    if count>#nexts then
                        count = 1
                    end
                end
                gooi.alert({
                    big = true,
                    text = "Welcome, here are the controls:"..controls,
                    ok = function(r)
                        gooi.confirm({
                            text = "Configure controls?",
                            ok = function(r)
                                GSS(Config:new())
                            end
                        })
                    end
                })
            else
                gooi.alert({
                    text = "Welcome to \nDust: Battle Beneath!"
                })
            end
            game:saveSettings()
        end
    end)
end

function Scene:convertPixelToTile(x,y)
    local xx,yy = x/16,--self.parent.tileW,
    y/16--self.parent.tileH
    if xx<1 then xx = xx+1 end
    if yy<1 then yy = yy+1 end
    return xx,yy
end

function Scene:mousereleased()
    self:endScene()
end
return Scene